package io.keikai.importer;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author RaymondChao
 */
public class Drawings implements Iterable<ShapeJson> {
    List<ShapeJson> _drawingsJson;
    int _shapeIdCount = 2; // start from 2, like Excel to create a picture
    public Drawings(List<ShapeJson> drawingsJson) {
        if (drawingsJson == null) {
            _drawingsJson = new LinkedList();
        } else {
            _drawingsJson = drawingsJson;
            _findMaxId();
        }
    }

    @Override
    public Iterator<ShapeJson> iterator() {
        return _drawingsJson.iterator();
    }

    List<PictureJson> getPictures() {
        final List<PictureJson> picList = _drawingsJson.stream()
                .filter((t) -> t instanceof PictureJson)
                .map((t) -> (PictureJson) t)
                .collect(Collectors.toList());
        return picList;
    }

    void _findMaxId() {
        // find max shapeIdCount
        getPictures().forEach((pic) -> {
            final int id = Integer.parseInt(pic.getUuid());
            if (id >= _shapeIdCount) {
                _shapeIdCount = id + 1;
            }
        });
//        this.charts.forEach((chart) {
//        final id = int.tryParse(chart.uuid) ?? -1;
//        if (id >= shapeIdCount) {
//            shapeIdCount = id + 1;
//        }
//    });
    }
}
