/* SheetData.java

	Purpose:
		
	Description:
		
	History:
		3:40 PM 03/07/2017, Created by jumperchen

Copyright (C) 2017 Potix Corporation. All Rights Reserved.
*/
package io.keikai.importer.xml;

import java.util.Map;

import io.keikai.json.JSONArray;
import io.keikai.json.JSONAware;
import io.keikai.json.JSONValue;

/**
 * see http://www.datypic.com/sc/ooxml/e-ssml_sheetData-1.html
 * @author jumperchen
 */
public class SheetData implements JSONNode {
	private JSONArray<JSONAware> sheetData = new JSONArray<>();

	public String toJSONString() {
		StringBuilder rows = new StringBuilder();
		rows.append("{");
		JSONValue.toJSONString("row", this.sheetData, rows);
		rows.append("}");
		return rows.toString();
	}

	public void addAttributes(Map<String, String> attributes) {
		throw new IllegalArgumentException("Unknown attributes [" + attributes + "]");
	}

	public void addElement(String name, JSONAware element) {
		if ("row".equals(name)) {
			sheetData.add(element);
		} else {
			throw new IllegalArgumentException("Unknown element [" + name + "]");
		}
	}

	public void addContent(String text) {
		if (!text.trim().isEmpty()) // KEIKAI-402
			throw new UnsupportedOperationException("Unsupported content value: [" + text + "]");
	}

	public Object get(String key) {
		if ("row".equals(key))
			return sheetData;
		throw new IllegalArgumentException("Unknown key [" + key + "]");
	}

}
