/* SBorder.java

	Purpose:
		
	Description:
		
	History:
		Mar 31, 2015 4:45:11 PM, Created by henrichen

	Copyright (C) 2015 Potix Corporation. All Rights Reserved.
*/

package io.keikai.model;

/**
 * Border object
 * @author henri
 * @since 3.8.0
 */
public interface SBorder {

	/**
	 * The border type
	 * @since 3.5.0
	 */
	public static enum BorderType {
		NONE, THIN, MEDIUM, DASHED, HAIR, THICK, DOUBLE, DOTTED, 
		MEDIUM_DASHED, DASH_DOT, MEDIUM_DASH_DOT, DASH_DOT_DOT, 
		MEDIUM_DASH_DOT_DOT, SLANTED_DASH_DOT;
	}
	
	/**
	 * @return left border
	 */
	public BorderType getBorderLeft();
	@Deprecated public void setBorderLeft(BorderType type);

	/**
	 * @return top border
	 */
	public BorderType getBorderTop();
	@Deprecated public void setBorderTop(BorderType type);

	/**
	 * @return right border
	 */
	public BorderType getBorderRight();
	@Deprecated public void setBorderRight(BorderType type);

	/**
	 * @return bottom border
	 */
	public BorderType getBorderBottom();
	@Deprecated public void setBorderBottom(BorderType type);

	/**
	 * @return vertical border
	 */
	public BorderType getBorderVertical();
	@Deprecated public void setBorderVertical(BorderType type);
	
	/**
	 * @return horizontal border
	 */
	public BorderType getBorderHorizontal();
	@Deprecated public void setBorderHorizontal(BorderType type);
	
	/**
	 * @return diagonal border
	 */
	public BorderType getBorderDiagonal();
	@Deprecated public void setBorderDiagonal(BorderType type);
	
	/**
	 * @return top border color
	 */
	public io.keikai.model.SColor getBorderTopColor();
	@Deprecated public void setBorderTopColor(io.keikai.model.SColor color);

	/** 
	 * @return left border color
	 */
	public io.keikai.model.SColor getBorderLeftColor();
	@Deprecated public void setBorderLeftColor(io.keikai.model.SColor color);

	/**
	 * 
	 * @return bottom border color
	 */
	public io.keikai.model.SColor getBorderBottomColor();
	@Deprecated public void setBorderBottomColor(io.keikai.model.SColor color);

	/**
	 * @return right border color
	 */
	public io.keikai.model.SColor getBorderRightColor();
	@Deprecated public void setBorderRightColor(io.keikai.model.SColor color);

	/**
	 * @return vertical border color
	 */
	public io.keikai.model.SColor getBorderVerticalColor();
	@Deprecated public void setBorderVerticalColor(io.keikai.model.SColor color);
	
	/**
	 * @return horizontal border color
	 */
	public io.keikai.model.SColor getBorderHorizontalColor();
	@Deprecated public void setBorderHorizontalColor(io.keikai.model.SColor color);
	
	/**
	 * @return diagonal border color
	 */
	public io.keikai.model.SColor getBorderDiagonalColor();
	@Deprecated public void setBorderDiagonalColor(io.keikai.model.SColor color);
	
    /**
     * Whether show diagonalUp diagonal border
     * @return
     */
    public boolean isShowDiagonalUpBorder();
	@Deprecated public void setShowDiagonalUpBorder(boolean show);
    
    /**
     * Whether show diagonalDown diagonal border
     * @return
     */
    public boolean isShowDiagonalDownBorder();
	@Deprecated public void setShowDiagonalDownBorder(boolean show);
	
	/**
	 * Returns left border line.
	 * @return
	 */
	public io.keikai.model.SBorderLine getLeftLine();
	/**
	 * Returns top border line
	 * @return
	 */
	public io.keikai.model.SBorderLine getTopLine();
	/**
	 * Returns right border line
	 * @return
	 */
	public io.keikai.model.SBorderLine getRightLine();
	/**
	 * Returns bottom border line
	 * @return
	 */
	public io.keikai.model.SBorderLine getBottomLine();
	/**
	 * Returns diagonal border line
	 * @return
	 */
	public io.keikai.model.SBorderLine getDiagonalLine();
	
	/**
	 * Returns vertical border line
	 * @return
	 */
	public io.keikai.model.SBorderLine getVerticalLine();
	
	/**
	 * Returns horizontal border line
	 * @return
	 */
	public io.keikai.model.SBorderLine getHorizontalLine();
	
}
