package io.keikai.model;

public interface SFontBuilder extends StyleBuilder<SFont> {
    /**
     * Sets the font's color.
     */
    SFontBuilder color(String color);

    /**
     * Sets the font's name like "Calibri".
     */
    SFontBuilder name(String name);

    /**
     * Sets the font's height point.
     */
    SFontBuilder heightPoints(int heightPoints);

    /**
     * Sets the font's bold style.
     */
    SFontBuilder boldweight(SFont.Boldweight boldweight);

    /**
     * Sets if the font is italic.
     */
    SFontBuilder italic(boolean italic);

    /**
     * Sets if the font is strike-out.
     */
    SFontBuilder strikeout(boolean strikeout);

    /**
     * Sets the font's type offset.
     */
    SFontBuilder typeOffset(SFont.TypeOffset typeOffset);

    /**
     * Sets the font's underline style.
     */
    SFontBuilder underline(SFont.Underline underline);
}
