/*

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		2013/12/01 , Created by dennis
}}IS_NOTE

Copyright (C) 2013 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package io.keikai.model;
/**
 * A picture in a sheet.
 * @author dennis
 * @since 3.5.0
 */
public interface SPicture {
	/**
	 * @since 3.5.0
	 */
	public enum Format{
		DIB,
		EMF,
		GIF,
		JPG,
		PICT,
		PNG,
		WMF;
		public String getFileExtension() {
			return name().toLowerCase();
		}
		
		/**
		 * Convert file extension to picture format
		 * @param fileExtension
		 * @return null if no corresponding format found
		 */
		public static Format valueOfFileExtension(String fileExtension) {
			if ("dib".equalsIgnoreCase(fileExtension)) {
				return DIB;
			} else if ("emf".equalsIgnoreCase(fileExtension)) {
				return EMF;
			} else if ("gif".equalsIgnoreCase(fileExtension)) {
				return GIF;
			} else if ("jpg".equalsIgnoreCase(fileExtension) || "jpeg".equalsIgnoreCase(fileExtension)) {
				return JPG;
			} else if ("pct".equalsIgnoreCase(fileExtension) || "pict".equalsIgnoreCase(fileExtension) || "pic".equalsIgnoreCase(fileExtension)) {
				return PICT;
			} else if ("png".equalsIgnoreCase(fileExtension)) {
				return PNG;
			} else if ("wmf".equalsIgnoreCase(fileExtension)) {
				return WMF;
			}
			return null;
		}
		
	}
	public SSheet getSheet();
	
	public String getId();
	
	public Format getFormat();
	
	public byte[] getData();
	
	public ViewAnchor getAnchor();

	void setAnchor(ViewAnchor anchor);
	
	/**
	 * Returns the SPictureData
	 * @since 3.6.0
	 * @return
	 */
	public SPictureData getPictureData();
}
