/*

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		2013/12/01 , Created by dennis
}}IS_NOTE

Copyright (C) 2013 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package io.keikai.model;

import java.util.Iterator;

/**
 * A row of a sheet.
 * @author dennis
 * @since 3.5.0
 */
public interface SRow extends CellStyleHolder{

	public SSheet getSheet();
	
	/**
	 * @return 0-based row index
	 */
	public int getIndex();
//	public String asString();
	public boolean isNull();
	
	/**
	 * @return height in pixels
	 */
	public int getHeight();
	public boolean isHidden();
	public boolean isCustomHeight();
	
	public void setHeight(int height);
	public void setHidden(boolean hidden);
	
	/**
	 * @param custom TRUE, if the height is set by users and is not calculated by system automatically
	 */
	public void setCustomHeight(boolean custom);

	/**
	 *
	 * @return
	 * @since 3.7.0
	 */
	public Iterator<SCell> getCellIterator();

	/**
	 *
	 * @return
	 * @since 5.0.0
	 */
	public Iterator<SCell> getCellIterator(int start, int end);

	/**
	 * Set row groupings (like groupRow) in a stream-friendly manner
	 *
	 * <p>
	 *    groupRows requires all rows in the group to be in the current window.
	 *    This is not always practical.  Instead use setOutlineLevel to
	 *    explicitly set the group level.  Level 1 is the top level group,
	 *    followed by 2, etc.  It is up to the user to ensure that level 2
	 *    groups are correctly nested under level 1, etc.
	 * </p>
	 * <p>Note: The maximum outlines are up to eight levels.
	 * @param outlineLevel     outline level (greater than 0)
	 * @since 6.0.0
	 */
	public void setOutlineLevel(int outlineLevel);

	/**
	 * Returns the row groupings
	 * @since 6.0.0
	 */
	public int getOutlineLevel();
	/**
	 * Returns true if it has "collapsed" attribute
	 * @since 6.0.0
	 */
	public boolean isCollapsed();

	/**
	 * Sets the "collapsed" attribute
	 * @since 6.0.0
	 */
	public void setCollapsed(boolean collapsed);

	/**
	 * Get height directly.
	 * Internal used only.
	 * @since 6.0.0
	 */
	default Integer getHeightDirectly() {return getHeight();}
}
