package io.keikai.model;

/**
 * Workbook protection options
 *
 * @since 5.8.0
 */
public interface SWorkbookProtection {

    /**
     * Lock the structure of the workbook
     *
     * @param lockStructure whether to lock the structure of the workbook
     */
    void setLockStructure(Boolean lockStructure);

    /**
     * Returns if the structure of the workbook is locked
     */
    Boolean isLockStructure();

    /**
     * Lock the windows of the workbook
     *
     * @param lockWindows whether to lock the window of the workbook
     */
    void setLockWindows(Boolean lockWindows);

    /**
     * Returns if the windows of the workbook is locked
     */
    Boolean isLockWindows();
}
