/*

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		2013/12/01 , Created by dennis
}}IS_NOTE

Copyright (C) 2013 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package io.keikai.model.impl;

import java.io.Serializable;
import java.util.List;

import io.keikai.model.SChart;
import io.keikai.model.SColor;
import io.keikai.model.chart.SChartData;

/**
 * 
 * @author dennis
 * @since 3.5.0
 */
public abstract class AbstractChartAdv implements SChart, LinkedModelObject, Serializable{
	private static final long serialVersionUID = 1L;

	/**
	 * Sets the default colors for series. When all colors are used, rollback to beginning again.
	 * @since 5.3.0
	 */
	public abstract void setSeriesColors(List<SColor> colors);

	/**
	 * Gets the default colors for series
	 * @since 5.3.0
	 */
	public abstract List<SColor> getSeriesColors();


	public abstract List<SChartData> getChartData();

	/**
	 * this method will return specified chart data with category and series values
	 *
	 * @param type chart type
	 * @return specified chart data.
	 */
	public abstract SChartData createChartData(SChart.ChartType type);

	public abstract void addChartData(SChartData chartData);

	public abstract Boolean isAutoTitleDeleted();
	public abstract void setAutoTitleDeleted(Boolean autoTitleDeleted);

	public abstract boolean isShowTitle();
	public abstract void setShowTitle(boolean showTitle);

	// default: true
	public abstract boolean isShowDataLabelsOverMax();
	public abstract void setShowDataLabelsOverMax(boolean showDataLabelsOverMax);

	public abstract void setSparklineNegativePointVisible(boolean visible);
	public abstract boolean isSparklineNegativePointVisible();

	public abstract void setSparklineFirstPointVisible(boolean visible);
	public abstract boolean isSparklineFirstPointVisible();

	public abstract void setSparklineLastPointVisible(boolean visible);
	public abstract boolean isSparklineLastPointVisible();

	public abstract void setSparklineHighPointVisible(boolean visible);
	public abstract boolean isSparklineHighPointVisible();

	public abstract void setSparklineLowPointVisible(boolean visible);
	public abstract boolean isSparklineLowPointVisible();

	public abstract void setSparklineMarkerVisible(boolean show);
	public abstract boolean isSparklineMarkerVisible();

	public abstract void setSparklineSeriesColor(SColor color);
	public abstract SColor getSparklineSeriesColor();

	public abstract void setSparklineNegativePointColor(SColor color);
	public abstract SColor getSparklineNegativePointColor();

	public abstract void setSparklineFirstPointColor(SColor color);
	public abstract SColor getSparklineFirstPointColor();

	public abstract void setSparklineLastPointColor(SColor color);
	public abstract SColor getSparklineLastPointColor();

	public abstract void setSparklineHighPointColor(SColor color);
	public abstract SColor getSparklineHighPointColor();

	public abstract void setSparklineLowPointColor(SColor color);
	public abstract SColor getSparklineLowPointColor();

	public abstract void setSparklineMarkerColor(SColor color);
	public abstract SColor getSparklineMarkerColor();
}
