/*
{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Aug 22, 2014, Created by henri
}}IS_NOTE

Copyright (C) 2014 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/

package io.keikai.model.impl;

import io.keikai.model.SColor;
import io.keikai.model.sys.formula.FormulaExpression;
import io.keikai.model.chart.SSeries;

import java.util.Map;

/**
 * Handle formula caching for chart series data.
 * @author henri
 * @since 3.6.0
 */
public abstract class AbstractSeriesAdv implements SSeries {

	/**
	 * @since 3.6.0
	 */
	public abstract FormulaExpression getNameFormulaExpression();
	
	/**
	 * 
	 * @return
	 * @since 3.6.0	 
	 */
	public abstract FormulaExpression getValuesFormulaExpression();
	
	/**
	 * 
	 * @return
	 * @since 3.6.0
	 */
	public abstract FormulaExpression getXValuesFormulaExpression();
	
	/**
	 * 
	 * @return
	 * @since 3.6.0
	 */
	public abstract FormulaExpression getYValuesFormulaExpression();
	
	/**
	 * 
	 * @return
	 * @since 3.6.0
	 */
	public abstract FormulaExpression getZValuesFormulaExpression();

	/**
	 *
	 * @since 3.6.0
	 */
	public abstract void setXYZFormula(FormulaExpression nameExpr, FormulaExpression xValuesExpr, FormulaExpression yValuesExpr, FormulaExpression zValuesExpr);

	/**
	 * data point colors
	 * @since 5.2.0
	 */
	public abstract SColor getDefaultColor();

	public abstract void setDefaultColor(SColor defaultColor);

	public abstract Map<Integer, SColor> getDataPointColors();

	public abstract void addDataPointColors(int index, SColor color);

	/**
	 * @since 5.3.0
	 */
	public abstract int getOrder();
	public abstract void setOrder(int order);

	/**
	 * @since 5.3.0
	 */
	public abstract boolean isSmooth();
	public abstract void setSmooth(boolean _smooth);

	/**
	 * @sinde 6.0.0
	 */
	public abstract boolean isDataLabelsVisible();
	public abstract void setDataLabelsVisible(boolean dataLabelsVisible);
}
