/* ChartAxisImpl.java

	Purpose:
		
	Description:
		
	History:
		Nov 11, 2014 10:53:47 AM, Created by henrichen

	Copyright (C) 2014 Potix Corporation. All Rights Reserved.
*/

package io.keikai.model.impl;

import java.io.Serializable;

/**
 * @author henri
 *
 */
public abstract class ChartAxisImpl extends AbstractChartAxisAdv implements Serializable {
	private static final long serialVersionUID = 2598887754686809214L;
	final private long id;
	final private Position position;
	private Double min;
	private Double max;
	private String format;
	private long crossAxisId;
	private final Orientation orientation;
	private final TickLabelPosition tickLabelPosition;
	private final Crosses axisCrosses;
	private final boolean majorGridline;
	private final boolean visible;

	public ChartAxisImpl(long id, Position position, Double min, Double max,
						 String format, Orientation orientation,
						 TickLabelPosition tickLabelPosition, long crossAxisId,
						 Crosses axisCrosses, boolean majorGridline, boolean visible) {
		this.id = id;
		this.position = position;
		this.min = min;
		this.max = max;
		this.format = format;
		this.orientation = orientation;
		this.tickLabelPosition = tickLabelPosition;
		this.crossAxisId = crossAxisId;
		this.axisCrosses = axisCrosses;
		this.majorGridline = majorGridline;
		this.visible = visible;
	}

	@Override
	public long getId() {
		return id;
	}

	@Override
	public boolean isVisible() {
		return visible;
	}

	@Override
	public Position getPosition() {
		return position;
	}

	@Override
	public boolean hasMajorGridline() {
		return majorGridline;
	}

	@Override
	public Orientation getOrientation() {
		return orientation;
	}

	@Override
	public TickLabelPosition getTickLabelPosition() {
		return tickLabelPosition;
	}

	@Override
	public Double getMax() {
		return max;
	}

	@Override
	public void setMax(Double max) {
		this.max = max;
	}

	@Override
	public Double getMin() {
		return min;
	}

	@Override
	public void setMin(Double min) {
		this.min = min;
	}

	@Override
	public String getFormat() {
		return format;
	}

	@Override
	public void setFormat(String format) {
		this.format = format;
	}

	@Override
	public long getCrossAxisId() {
		return crossAxisId;
	}

	@Override
	public void setCrossAxisId(long crossAxisId) {
		this.crossAxisId = crossAxisId;
	}

	@Override
	public Crosses getAxisCrosses() {
		return axisCrosses;
	}
}
