package io.keikai.model.impl;

import io.keikai.model.sys.dependency.OffsetRef;

/**
 * a cell reference produced by OFFSET function.
 */
public class OffsetRefImpl extends RefImpl implements OffsetRef {
    private static final long serialVersionUID = -1100467728876916345L;
    final int _ptgIndex;

    public OffsetRefImpl(String bookName, String sheetName, int ptgIndex) {
        super(RefType.OFFSET, bookName, sheetName, null, -1, -1,-1,-1);
        _ptgIndex = ptgIndex;
    }

    @Override
    public int getPtgIndex() {
        return _ptgIndex;
    }

    // Override hashCode() and equals(); each instance should be unique.
    @Override
    public int hashCode() {
        return System.identityHashCode(this);
    }

    @Override
    public boolean equals(Object obj) {
        return this == obj;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder(super.toString());
        if (sheetName != null) {
            sb.append(sheetName).append(":");
        }
        sb.append("OFFSET@").append(hashCode());
        return sb.toString();
    }
}
