package io.keikai.model.impl.chart;

import io.keikai.model.SChart;
import io.keikai.model.impl.AbstractChartAdv;

/**
 * @since 5.3.0
 */
public class BarChartDataImpl extends GroupingChartDataImpl {
    private static final long serialVersionUID = 2296771451941594787L;
    private SChart.BarDirection direction;
    private int overlap;


    public BarChartDataImpl(AbstractChartAdv chart, String id, SChart.BarDirection direction) {
        super(chart, id);
        this.direction = direction;
    }

    public SChart.BarDirection getBarDirection() {
        return direction;
    }

    public int getBarOverlap() {
        return overlap;
    }

    public void setBarOverlap(int overlap) {
        this.overlap = overlap;
    }

    @Override
    public SChart.ChartType getType() {
        return direction == SChart.BarDirection.HORIZONTAL ? SChart.ChartType.BAR : SChart.ChartType.COLUMN;
    }

    @Override
    public void copyFrom(GeneralChartDataImpl src) {
        super.copyFrom(src);
        if (src instanceof BarChartDataImpl) {
            overlap = ((BarChartDataImpl) src).overlap;
            direction = ((BarChartDataImpl) src).direction;
        }
    }
}
