package io.keikai.model.impl.chart;

import io.keikai.model.impl.ChartAxisImpl;

/**
 * @since 5.3.0
 */
public class CategoryAxisImpl extends ChartAxisImpl {
    private static final long serialVersionUID = 630235696937441186L;
    private final LabelAlign labelAlign;
    private final int labelOffset;
    public CategoryAxisImpl(long id, Position position, Double min, Double max,
                            String format, Orientation orientation,
                            TickLabelPosition tickLabelPosition, long crossAxisId,
                            Crosses axisCrosses, LabelAlign labelAlign, int labelOffset,
                            boolean majorGridline, boolean visible) {
        super(id, position, min, max, format, orientation, tickLabelPosition, crossAxisId, axisCrosses, majorGridline,
                visible);
        this.labelAlign = labelAlign;
        this.labelOffset = labelOffset;
    }

    @Override
    public SChartAxisType getType() {
        return SChartAxisType.CATEGORY;
    }

    public LabelAlign getLabelAlign() {
        return labelAlign;
    }

    public int getLabelOffset() {
        return labelOffset;
    }

    public CategoryAxisImpl cloneCategoryAxisImpl(long id) {
        return new CategoryAxisImpl(id, getPosition(), getMin(), getMax(), getFormat(), getOrientation(),
                getTickLabelPosition(), getCrossAxisId(), getAxisCrosses(), getLabelAlign(), getLabelOffset(),
                hasMajorGridline(), isVisible());
    }

    public enum LabelAlign {
        LEFT,
        RIGHT,
        CENTER
    }
}
