package io.keikai.model.impl.chart;

import io.keikai.model.SChart;
import io.keikai.model.impl.AbstractChartAdv;

/**
 * @since 5.3.0
 */
public class LineChartDataImpl extends GroupingChartDataImpl {
    private static final long serialVersionUID = 2176997414763661810L;

    private boolean smooth;
    private Boolean marker;

    public LineChartDataImpl(AbstractChartAdv chart, String id) {
        super(chart, id);
    }

    @Override
    public SChart.ChartType getType() {
        return SChart.ChartType.LINE;
    }

    public boolean isSmooth() {
        return smooth;
    }

    public void setSmooth(boolean smooth) {
        this.smooth = smooth;
    }

    @Override
    public void copyFrom(GeneralChartDataImpl src) {
        super.copyFrom(src);
        if (src instanceof GroupingChartDataImpl) {
            smooth = ((LineChartDataImpl) src).smooth;
            marker = ((LineChartDataImpl) src).marker;
        }
    }

    public Boolean hasMarker() {
        return marker;
    }

    public void setMarker(Boolean marker) {
        this.marker = marker;
    }
}
