package io.keikai.model.impl.chart;

import io.keikai.model.impl.ChartAxisImpl;

/**
 * @since 5.3.0
 */
public class ValueAxisImpl extends ChartAxisImpl {
    private static final long serialVersionUID = -912078016171552249L;
    private final CrossBetween crossBetween;

    public ValueAxisImpl(long id, Position position, Double min, Double max,
                         String format, Orientation orientation,
                         TickLabelPosition tickLabelPosition, long crossAxisId,
                         Crosses axisCrosses, CrossBetween crossBetween, boolean majorGridline, boolean visible) {
        super(id, position, min, max, format, orientation, tickLabelPosition, crossAxisId, axisCrosses, majorGridline,
                visible);
        this.crossBetween = crossBetween;
    }

    @Override
    public SChartAxisType getType() {
        return SChartAxisType.VALUE;
    }

    public CrossBetween getCrossBetween() {
        return crossBetween;
    }

    public ValueAxisImpl cloneValueAxisImpl(long id) {
        return new ValueAxisImpl(id, getPosition(), getMin(), getMax(), getFormat(), getOrientation(),
                getTickLabelPosition(), getCrossAxisId(), getAxisCrosses(), getCrossBetween(), hasMajorGridline(),
                isVisible());
    }

    public enum CrossBetween {
        BETWEEN,
        MIDPOINT_CATEGORY
    }
}
