/*

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		2013/12/01 , Created by dennis
}}IS_NOTE

Copyright (C) 2013 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package io.keikai.range;

import java.io.File;
import java.io.IOException;
import java.io.OutputStream;

import io.keikai.model.CellRegion;
import io.keikai.model.SBook;
import io.keikai.model.SSheet;
import io.keikai.model.SheetRegion;

/**
 * An exporter can export a book model to a output stream or file.
 * @author dennis
 * @since 3.5.0
 */
public interface SExporter {
	/**
	 * Export a book
	 * @param book the book to export
	 * @param fos the output stream to store data
	 * @throws IOException
	 */
	public void export(SBook book, OutputStream fos) throws IOException;
	
	/**
	 * Export a book
	 * @param book the book to export
	 * @param file the output file to store data
	 * @throws IOException
	 */
	public void export(SBook book, File file) throws IOException;
}
