/*

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		
}}IS_NOTE

Copyright (C) 2013 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package io.keikai.range.impl;

import java.util.List;
import java.util.Objects;

import io.keikai.model.*;
import io.keikai.model.SBorder.BorderType;
import io.keikai.model.impl.AbstractSheetAdv;
import io.keikai.range.SRange;
/**
 * 
 * @author Dennis
 * @since 3.5.0
 */
public class MergeHelper extends RangeHelperBase{

	public MergeHelper(SRange range) {
		super(range);
	}
	
	//BookHelper, public static ChangeInfo unMerge(XSheet sheet, int tRow, int lCol, int bRow, int rCol,boolean overlapped) {
	public void unmerge(boolean overlapped) {
		int tRow = getRow();
		int lCol = getColumn();
		int bRow = getLastRow();
		int rCol = getLastColumn();
		
		sheet.removeMergedRegion(new CellRegion(tRow,lCol,bRow,rCol),overlapped);

//		for(int j = sheet.getNumOfMergedRegion() - 1; j >= 0; --j) {
//        	final CellRegion merged = sheet.getMergedRegion(j);
//        	
//        	final int firstCol = merged.getColumn();
//        	final int lastCol = merged.getLastColumn();
//        	final int firstRow = merged.getRow();
//        	final int lastRow = merged.getLastRow();
//        	
//        	// ZSS-395 unmerge when any cell overlap with merged region
//        	// ZSS-412 use a flag to decide to check overlap or not.
//        	if( (overlapped && overlap(firstRow, firstCol, lastRow, lastCol, tRow, lCol, bRow, rCol)) || 
//        			(!overlapped && contain(tRow, lCol, bRow, rCol,firstRow, firstCol, lastRow, lastCol)) ) {
//				sheet.removeMergedRegion(merged);
//        	}
//		}
	}
	
	//a b are overlapped.
//	private static boolean overlap(int aTopRow, int aLeftCol, int aBottomRow, int aRightCol,
//			int bTopRow, int bLeftCol, int bBottomRow, int bRightCol) {
//		
//		boolean xOverlap = between(aLeftCol, bLeftCol, bRightCol) || between(bLeftCol, aLeftCol, aRightCol);
//		boolean yOverlap = between(aTopRow, bTopRow, bBottomRow) || between(bTopRow, aTopRow, aBottomRow);
//		
//		return xOverlap && yOverlap;
//	}
	
	//a contains b
//	private static boolean contain(int aTopRow, int aLeftCol, int aBottomRow, int aRightCol,
//			int bTopRow, int bLeftCol, int bBottomRow, int bRightCol){
//		return aLeftCol <= bLeftCol && aRightCol >= bRightCol 
//        		&& aTopRow <= bTopRow && aBottomRow >= bBottomRow;
//	}
//	
//	private static boolean between(int value, int min, int max) {
//		return (value >= min) && (value <= max);
//	}
	
	/*
	 * Merge the specified range per the given tRow, lCol, bRow, rCol.
	 * 
	 * @param sheet sheet
	 * @param tRow top row
	 * @param lCol left column
	 * @param bRow bottom row
	 * @param rCol right column
	 * @param across merge across each row.
	 * @return {@link Ref} array where the affected formula cell references in index 1 and to be evaluated formula cell references in index 0.
	 */
//	@SuppressWarnings("unchecked")
	public void merge(boolean across) {
		int tRow = range.getRow();
		int lCol = range.getColumn();
		int bRow = range.getLastRow();
		int rCol = range.getLastColumn();
		
		List<CellRegion> overlaps = sheet.getOverlapsMergedRegions(new CellRegion(tRow,lCol,bRow,rCol),false); 
		
		if(overlaps.size()>0){
			//to backward comparable to old sepc. we should unmerge it
//			throw new InvalidateModelOpException("can't merge an overlapped region "+overlaps.get(0).getReferenceString()+", unmerge it first");
			unmerge(true);
		}
		
		if (across) {
			for(int r = tRow; r <= bRow; ++r) {
				merge0(sheet, r, lCol, r, rCol);
			}
		} else {
			merge0(sheet, tRow, lCol, bRow, rCol);
		}
	}
	
	//ZSS-1217
	private void setRowCustomHeight(SSheet sheet, int r) {
		final SRow row = sheet.getRow(r);
		final int ht = row.getHeight();
		final int defaultHt = sheet.getDefaultRowHeight();
		if (ht != defaultHt) {
			row.setCustomHeight(true);
		}
	}
	
	private void merge0(SSheet sheet, int tRow, int lCol, int bRow, int rCol) {
		if (tRow == bRow && lCol == rCol)
			return;
//		final List<MergeChange> changes = new ArrayList<MergeChange>();
//		final Set<CellRegion> all = new HashSet<CellRegion>();
//		final Set<CellRegion> last = new HashSet<CellRegion>();
		//find the left most non-blank cell.
		SCell target = null;
		for(int r = tRow; target == null && r <= bRow; ++r) {
			for(int c = lCol; c <= rCol; ++c) {
				final SCell cell = sheet.getCell(r, c);
				if (!isBlank(cell)) {
					target = cell;
					break;
				}
			}
		}
		SBorderLine lBorder = null;
		SBorderLine tBorder = null;
		SBorderLine rBorder = null;
		SBorderLine bBorder = null;
		final SCell tlCell = sheet.getCell(tRow, lCol);
		SBorder tlBd =  tlCell.getCellStyle().getBorder();
		if (tlBd != null) {
			lBorder = tlBd.getLeftLine();
			tBorder = tlBd.getTopLine();
		}
		final SCell brCell = sheet.getCell(bRow, rCol);
		SBorder brBd = brCell.getCellStyle().getBorder();
		if (brBd != null) {
			rBorder = brBd.getRightLine();
			bBorder = brBd.getBottomLine();
		}
		SBorderLine defaultLBorder = null;
		SBorderLine defaultTBorder = null;
		SBorderLine defaultRBorder = null;
		SBorderLine defaultBBorder = null;
		final SBorder sb = sheet.getBook().getDefaultCellStyle().getBorder();
		if (sb != null) {
			defaultLBorder = sb.getLeftLine();
			defaultTBorder = sb.getTopLine();
			defaultRBorder = sb.getRightLine();
			defaultBBorder = sb.getBottomLine();
		}
		boolean checkLeft = true;
		boolean checkTop = true;
		boolean checkRight = true;
		boolean checkBottom = true;
		if (Objects.equals(tBorder, defaultTBorder)) {
			checkTop = false;
		}
		if (Objects.equals(lBorder, defaultLBorder)) {
			checkLeft = false;
		}
		if (Objects.equals(rBorder, defaultRBorder)) {
			checkRight = false;
		}
		if (Objects.equals(bBorder, defaultBBorder)) {
			checkBottom = false;
		}
		boolean check = true;
		if (!checkTop && !checkBottom && !checkLeft && !checkRight) {
			check = false;
		}
		if (check) {
			for (int r = tRow; r <= bRow; ++r) {
				if (r == tRow) {
					for (int c = lCol; c <= rCol; ++c) {
						final SCell cell = sheet.getCell(r, c);
						final SBorder border = cell.getCellStyle().getBorder();
						SBorderLine cellLBorder = null;
						SBorderLine cellTBorder = null;
						SBorderLine cellRBorder = null;
						if (border != null) {
							cellLBorder = border.getLeftLine();
							cellTBorder = border.getTopLine();
							cellRBorder = border.getRightLine();
						}
						if (checkTop && border != null && !Objects.equals(tBorder, cellTBorder)) {
							checkTop = false;
							tBorder = defaultTBorder;
						}
						if (checkLeft && c == lCol && !Objects.equals(lBorder, cellLBorder)) {
							checkLeft = false;
							lBorder = defaultLBorder;
						}
						if (checkRight && c == rCol && !Objects.equals(rBorder, cellRBorder)) {
							checkRight = false;
							rBorder = defaultRBorder;
						}
					}
				}
				if (r == bRow) {
					for (int c = lCol; c <= rCol; ++c) {
						final SCell cell = sheet.getCell(r, c);
						final SBorder border = cell.getCellStyle().getBorder();
						SBorderLine cellLBorder = null;
						SBorderLine cellRBorder = null;
						SBorderLine cellBBorder = null;
						if (border != null) {
							cellLBorder = border.getLeftLine();
							cellRBorder = border.getRightLine();
							cellBBorder = border.getBottomLine();
						}
						if (checkBottom && !Objects.equals(bBorder, cellBBorder)) {
							checkBottom = false;
							bBorder = defaultBBorder;
						}
						if (checkLeft && c == lCol && !Objects.equals(lBorder, cellLBorder)) {
							checkLeft = false;
							lBorder = defaultLBorder;
						}
						if (checkRight && c == rCol && !Objects.equals(rBorder, cellRBorder)) {
							checkRight = false;
							rBorder = defaultRBorder;
						}
					}
				}
				if (r != tRow && r != bRow) {
					SCell cell = sheet.getCell(r, lCol);
					SBorder border = cell.getCellStyle().getBorder();
					SBorderLine cellLBorder = null;
					SBorderLine cellRBorder = null;
					if (border != null) {
						cellLBorder = border.getLeftLine();
					}
					if (checkLeft && !Objects.equals(lBorder, cellLBorder)) {
						checkLeft = false;
						lBorder = defaultLBorder;
					}
					cell = sheet.getCell(r, rCol);
					border = cell.getCellStyle().getBorder();
					if (border != null) {
						cellRBorder = border.getRightLine();
					}
					if (checkRight && !Objects.equals(rBorder, cellRBorder)) {
						checkRight = false;
						rBorder = defaultRBorder;
					}
				}
			}
		}
		if (target == null) {
			target = sheet.getCell(tRow, lCol);;
		}
		SCellStyle style = null;
		if (target != null) { //found the target
			final int tgtRow = target.getRowIndex();
			final int tgtCol = target.getColumnIndex();
			final int nRow = tRow - tgtRow;
			final int nCol = lCol - tgtCol;
			if (nRow != 0 || nCol != 0) { //if target not the left-top one, move to left-top
//				final ChangeInfo info = BookHelper.moveRange(sheet, tgtRow, tgtCol, tgtRow, tgtCol, nRow, nCol);
				sheet.moveCell(tgtRow, tgtCol, tgtRow, tgtCol, nRow, nCol);
//				if (info != null) {
//					changes.addAll(info.getMergeChanges());
//					last.addAll(info.getToEval());
//					all.addAll(info.getAffected());
//				}
			}
			final SCellStyle source = target.getCellStyle();
			final SCellStyleBuilder csb = sheet.getBook().addCellStyle(source);
			if (lBorder != null) {
				csb.borderLeft(lBorder.getBorderType()).borderLeftColor(lBorder.getColor().getHtmlColor());
			}
			if (tBorder != null) {
				csb.borderTop(tBorder.getBorderType()).borderTopColor(tBorder.getColor().getHtmlColor());
			}
			if (rBorder != null) {
				csb.borderRight(rBorder.getBorderType()).borderRightColor(rBorder.getColor().getHtmlColor());
			}
			if (bBorder != null) {
				csb.borderBottom(bBorder.getBorderType()).borderBottomColor(bBorder.getColor().getHtmlColor());
			}
			style = csb.build();
			target.setCellStyle(style); //set all cell in the merged range to CellStyle of the target minus border
		}
		//1st row (exclude 1st cell)
		//ZSS-1217
		setRowCustomHeight(sheet, tRow);
		for (int c = lCol + 1; c <= rCol; ++c) {
			final SCell cell = sheet.getCell(tRow, c);
			if (style != null) {
				cell.setCellStyle(style); //set all cell in the merged range to CellStyle of the target
			}
			cell.setValue(null);
//				final Set<Ref>[] refs = BookHelper.setCellValue(cell, (RichTextString) null);
//				if (refs != null) {
//					last.addAll(refs[0]);
//					all.addAll(refs[1]);
//				}
		}
		//2nd row and after
		for(int r = tRow + 1; r <= bRow; ++r) {
			for(int c = lCol; c <= rCol; ++c) {
				final SCell cell = sheet.getCell(r, c);
				cell.setCellStyle(style); //set all cell in the merged range to CellStyle of the target minus border
				cell.setValue(null);
//					final Set<Ref>[] refs = BookHelper.setCellValue(cell, (RichTextString) null);
//					if (refs != null) {
//						last.addAll(refs[0]);
//						all.addAll(refs[1]);
//					}
			}
			//ZSS-1217
			setRowCustomHeight(sheet, r);
		}
		final CellRegion mergeArea = new CellRegion(tRow, lCol,bRow,rCol);
		sheet.addMergedRegion(mergeArea);
//		final Ref mergeArea = new AreaRefImpl(tRow, lCol, bRow, rCol, BookHelper.getRefSheet((XBook)sheet.getWorkbook(), sheet)); 
//		all.add(mergeArea);//should update the cell in the merge area.
//		changes.add(new MergeChange(null, mergeArea));
		
//		return new ChangeInfo(last, all, changes);
	}	

}
