/*

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		2013/12/01 , Created by Hawk
}}IS_NOTE

Copyright (C) 2013 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package io.keikai.range.impl.imexp;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Optional;

import io.keikai.importer.XlsxImporter;
import io.keikai.model.SBook;
import org.apache.poi.poifs.filesystem.FileMagic;

import org.zkoss.lang.Library;
/**
 * 
 * @author dennis
 * @author Hawk
 * @since 3.5.0
 */
public class ExcelImportAdapter extends AbstractImporter {

	@Override
	public SBook imports(InputStream is, String bookName) throws IOException {
		if(!is.markSupported()) {
			is = new BufferedInputStream(is, 8);
		}
		AbstractImporter importer = null;
		if (FileMagic.valueOf(is) == FileMagic.OLE2) {
			importer = new ExcelXlsImporter();
		}else if (FileMagic.valueOf(is) == FileMagic.OOXML) {
			importer = new XlsxImporter();//new ExcelXlsxImporter();
		}
		if (importer != null) {
			importer.setImportCache(this.isImportCache()); //ZSS-873
			return importer.imports(is, bookName);
		}
		throw new IllegalArgumentException("The input stream to be imported is neither an OLE2 stream, nor an OOXML stream");
	}
	
	//ZSS-873
	protected boolean isImportCache() {
		String importCache = Optional.ofNullable(Library.getProperty("io.keikai.import.cache")).orElse(Library.getProperty("org.zkoss.zss.import.cache", "false"));
		return "true".equalsIgnoreCase(importCache.trim());
	}
}
