/* Ref.java

	Purpose:
		
	Description:
		
	History:
		12:06 PM 15/05/2017, Created by jumperchen

Copyright (C) 2017 Potix Corporation. All Rights Reserved.
*/
package io.keikai.util;

/**
 * Ref is a reference for cell or range with 4 value :
 * 		top(top row), left(left column), bottom(last row) and right(last column).
 * @author jumperchen
 */
public class Ref {
	/**
	 * The maximum column size.
	 */
	public static int MAX_COL = 16384;

	/**
	 * The maximum row size.
	 */
	public static int MAX_ROW = 1048576;
	private int left;
	private int top;
	private int right; // inclusive
	private int bottom; // inclusive

	/*package*/ Ref(int left, int top) {
		this.left = left;
		this.top = top;
		this.right = left;
		this.bottom = top;
	}
	/*package*/ Ref(int left, int top, int right, int bottom) {
		this.left = left;
		this.top = top;
		this.right = right;
		this.bottom = bottom;
	}

	public boolean isCell() {
		return top == bottom && left == right;
	}

	public int getTop() {
		return top;
	}
	public int getLeft() {
		return left;
	}
	public int getRight() {
		return right;
	}
	public int getBottom() {
		return bottom;
	}
	public String toString() {
		return Converter.refToA1(this);
	}

	public int getCount() {
		return getColumnCount() * getRowCount();
	}
	public int getRowCount() {
		if (isCell())
			return 1;
		return bottom - top + 1;
	}
	public int getColumnCount() {
		if (isCell())
			return 1;
		return right - left + 1;
	}
}
