/* Span.java

	Purpose:

	Description:
		The implementation refers to SimpleSpan in Keikai dart version.
	History:
		10:23 AM 2019/11/22, Created by jumperchen

Copyright (C) 2019 Potix Corporation. All Rights Reserved.
*/
package io.keikai.util;

/**
 * @author jumperchen
 */
public class Span {
	/*package*/ int start;
	/*package*/ int length;
	public Span(int start, int length) {
		this.start = start;
		this.length = length;
	}
	public int getEnd() {
		return start + length;
	}
	public int getStart() {
		return start;
	}
	public void setEnd(int end) {
		length = end - start;
		if (length < 0) throw new IllegalStateException("End cannot be less than start");
	}
	public Span split(int index) {
		int end = getEnd();
		if (index < start || index >= end) {
			return null;
		}
		Span v = new Span(index, end - index);
		setEnd(index);
		return v;
	}

	public String toString() {
		return "[" + start + "->" + getEnd() + "]";
	}
}
