/* Button.js

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Jan 12, 2012 7:07:27 PM , Created by sam
}}IS_NOTE

Copyright (C) 2012 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
(function () {

if (zk.ie6_ && !jq.IE6_ALPHAFIX) {
	jq.IE6_ALPHAFIX = '.png';
}
var AU = {au: true},
	AbstractButtonHandler = {
		doMouseDown_: function (evt) {
			var wgt = this._wgt;
			if (wgt) {
				var sheet = wgt.sheetCtrl;
				if (this._pp) {//fake spreadsheet focus
					wgt.focus(false);
				} else if (sheet) {
					// ZSS-744: spreadsheet still has focus in IE when mouse down, need to force it to stop editing.
					if (zk.ie) {
						sheet.dp.stopEditing('refocus');
					}
					sheet._doMousedown(evt);
				}
			}
		},
		doMouseUp_: function (evt) {
			var wgt = this._wgt;
			if (wgt) {
				var sheet = wgt.sheetCtrl;
				if (this._pp) {//fake spreadsheet focus
					wgt.focus(false);
				} else if (sheet) {
					sheet._doMouseup(evt);
				}
			}
		}
	},
	AbstractPopupHandler = {
		doMouseDown_: function (evt) {
			var wgt = this._wgt;
			if (wgt) {//fake focus
				wgt.focus(false);
			}
		},
		doMouseUp_: function (evt) {
			var wgt = this._wgt;
			if (wgt) {//fake focus
				wgt.focus(false);
			}
		}
	};

var urlCache = {};
function getScript(url, callback) {
	if (!urlCache[url]) {
		callback = callback || {};
		jq.ajax({
			 type: "GET",
			 url: url,
			 success: function (data) {
			 	urlCache[url] = data;
			 	callback(data);
			 },
			 dataType: "script",
			 cache: true
		 });
	} else if (callback) {
		callback(urlCache[url]);
	}
}

zss.SSToolbarbutton = zk.$extends(zul.wgt.Toolbarbutton, {
	_zclass: 'zss-toolbarbutton',
	$o: zk.$void,
	_actionIcon: null,
	//_defaultImage: null,
	/**
	 * The menupopup of the Toolbarbutton
	 */
	$init: function (props, wgt) {
		this.$supers(zss.SSToolbarbutton, '$init', [props]);
		this._wgt = wgt;
	},
	$define: {
		/**
		 * Represent button's action at server side
		 */
		$action: null,
		clickDisabled: null
	},
	//ZSS-1276
	$getAction: function () {
		return this._$aciton || this.$action;
	},
	setDisabled: function (actions) {
		if (actions) {
			var disable = this.isDisabled();
			if (actions.$contains(this.$getAction())) { //ZSS-1276
				if (!disable){
					this.$supers(zss.SSToolbarbutton, 'setDisabled', [true]);
				}
			} else if (disable) {//clear disabled
				this.$supers(zss.SSToolbarbutton, 'setDisabled', [false]);
			}
			
		} else {
			this.$supers(zss.SSToolbarbutton, 'setDisabled', arguments);
		}
	},
	setImage: function (v) {
		if (!this._defaultImage) {
			this._defaultImage = v;
		}
		this.$supers(zss.SSToolbarbutton, 'setImage', arguments);
	},
//	//ZSS-1171
	preSel: false,
//	preMenuItem: null,
	/**
	 * @param boolean true set UI selected effect, set false to remove
	 * @param zss.SSMenuitem the menuitem that selected
	 */
	setSelectedEffect: function (seld, menuitem, updateIcon) {
		//ZSS-1171: skip if same state
		 if (this.preSel == seld && this.preMenuItem == menuitem) {
		 	return;
		 }
		 this.preSel = seld;
		 this.preMenuItem = menuitem;

		 var pp = this.getPopup();
		 var $n = jq(this.$n());
		 var src = null;
		 if (seld && pp && menuitem) {
		 	var src = menuitem.getImage();
		 	this._seldImage = src;

		 	if (src) {
		 		this.setImage(src);
		 	}
		 	if (updateIcon && menuitem.$action != this._actionIcon) {
		 		var real = jq(this.$n('real'));
		 		real.addClass('k-icon-' + menuitem.$action);
		 		real.removeClass('k-icon-' + this._actionIcon);
		 		this._actionIcon = menuitem.$action;
		 	}
		 } else if (!menuitem) {
		 	this._seldImage = null;

		 	var src = this._defaultImage;
		 	if (src) {
		 		this.setImage(src);
		 	}
		 	$n.removeClass(this._getSclass() + '-seld');
		 	if (updateIcon && this._actionIcon != null) {
		 		jq(this.$n('real')).removeClass('k-icon-' + this._actionIcon);
		 		this._actionIcon = null;
		 	}
		 }

		 if (seld) {
		 	$n.addClass(this._getSclass() + '-seld');
		 } else {
		 	$n.removeClass(this._getSclass() + '-seld');
		 }
	},
	bind_: function () {
		this.$supers(zss.SSToolbarbutton, 'bind_', arguments);
		var cave = this.$n('cave');
		if (cave && !this._calWidth) { //contains menupopup, expand button width
			var disd = this.isClickDisabled(),
				seld = this._seldImage,
				scls = this._getSclass(),
				$n = jq(this.$n()),
				cnt = cave.parentNode,
				$cv = jq(cave),
				cw = $cv.width() + $cv.zk.sumStyles("lr", jq.paddings),
				w = $n.width() + $n.zk.sumStyles("lr", jq.paddings) + $n.zk.sumStyles("lr", jq.borders) + cw;
			if (w <= 49)//min size
				w = 49;
			this.setWidth(w + 'px');
			this._calWidth = true;//ZSS-216
			if (disd) {
				jq(cnt).addClass(scls + '-clk-disd');
			}
			if (seld) {
				$n.addClass(scls + '-seld');
			}
			jq(this.$n('real')).addClass('k-icon-' + this.$getAction());
		} else {
			jq(this.$n('cnt')).addClass('k-icon-' + this.$getAction());
		}
	},
	doClick_: function (evt) {
		var	cv = this.$n('cave'),
			taget = evt.domTarget;
		if(!this.isDisabled() && cv && jq.isAncestor(cv, taget)) {
			var pp = this._smartFellow(this.getPopup());
			if (pp) {
				pp.open(this, null, 'after_start');	
			}
		} else {
			if (this.isFireOnClick_(evt)) {
				this.fire('onClick');
			}
		}
		//controls fire onClick event, not invoke this.$supers('doClick_')
	},
	isFireOnClick_: function (evt) {
		return !this.isClickDisabled() && !this.isDisabled();
	},
	doMouseOver_: function (evt) {
		var	cv = this.$n('cave'),
			taget = evt.domTarget;
		if (!this.isDisabled() && cv) {
			if (jq.isAncestor(cv, taget)) {
				jq(cv).addClass(this._getSclass() + '-cave-over');
			}	
		}
		this.$supers(zss.SSToolbarbutton, 'doMouseOver_', arguments);
	},
	doMouseOut_: function (evt) {
		var cv = this.$n('cave');
		if (cv) {
			jq(cv).removeClass(this._getSclass() + '-cave-over');
		}
		this.$supers(zss.SSToolbarbutton, 'doMouseOut_', arguments);
	},
	domContent_: function () {
		var cnt = this.$supers(zss.SSToolbarbutton, 'domContent_', arguments);
		if (this.getPopup()) {
			var uid = this.uuid,
				scls = this._getSclass();
			return '<div id="' + uid + '-real" class="' + scls + '-real">' + 
				cnt + '</div><div id="' + uid + '-cave" class="' + 
				scls +'-cave"><div class="' + scls +'-arrow"></div></div>';
		} else {
			return cnt;
		}
	},
	_getSclass: function () {
		return 'zstbtn';
	},
	getSclass: function () {
        var result = 'zstbtn-' + this.$getAction() + ' ' + this._getSclass();
        if (this.getPopup()) {
            result += ' zstbtn-w-pp';
        }
        return result; //ZSS-1276
//		return 'zstbtn-' + this.$getAction() + ' ' + this._getSclass(); //ZSS-1276
	}
}, {
	_rmActive: function (wgt) {
		var n = wgt.$n(),
			cv = wgt.$n('cave');
		if (cv) {
			jq(cv).removeClass(wgt._getSclass() + '-cave-over');
		}
		jq(n)
		.removeClass(wgt._getSclass() + '-over')
		.removeClass(wgt.getZclass() + '-over');
	}
});
zk.copy(zss.SSToolbarbutton.prototype, AbstractButtonHandler);

if (zk.feature.pe) {
	zk.load('zkex.inp', null, function () {

		zss.ContentHandler = zk.$extends(zkex.inp.ContentHandler, {
			setContent: function (content) {
				if (!content || this._wgt.menupopup)
					return;

				this._content = content;
				var oldType = this._type,
					type = this._getType(content),
					wgt = this._wgt;

				if (oldType != type)
					this.destroy();

				this._type = type;
				switch (type) {
				case 'color':
					var hex = content.substr(content.indexOf('#color') + '#color'.length + 1);

					if (!this._color) {
						this._color = new zkex.inp.Color(hex);
						this._hex = this._color.getHex();
					} else {
						var c = this._color,
							img = wgt.$n('img');
						c.setHex(hex);
						if (img)
							img.style.backgroundColor = c.getHex();
					}

					if (!this._picker && !this._palette) {
						this._picker = new zkex.inp.Colorpicker({_wgt: this, _zclass: 'zss-colorpicker'});
						wgt.appendChild(this._picker);
						this._palette = new zss.SSColorpalette({_wgt: this});
						wgt.appendChild(this._palette);
						wgt.rerender(); // rerender in a timeout bug B50-3053311.zul PE only
					}
					break;
				case 'content':
					wgt.rerender();
					break;
				}
			}
		});

		zss.SSColorpalette = zk.$extends(zkex.inp.Colorpalette, {
		    _zclass: 'zss-colorpalette',
			redraw: function (out) {
        		var zcls = this.$s(),
        			uuid = this.uuid,
        			tagnm = zk.ie < 11 || zk.gecko ? 'a' : 'button',
        			i, j, k, index = 0;
        		out.push('<div id="', uuid, '" class="', zcls, '">',
        		'<div id="', uuid, '-newcolor" class="', this.$s('newcolor'), '"></div>',
        		'<input id="', uuid, '-hex-inp" class="', this.$s('input'), '" type="text" size="7" maxlength="7"></input>');

				for (r = 0; r < 6; r++) {
					for (g = 5; g >= 3; g--)
						for (b = 5; b >= 0; b--)
							out.push(this.getCell_(out, r * 0x33, g * 0x33, b * 0x33, zcls, index++));
				}
				for (r = 5; r >= 0; r--) {
					for (g = 2; g >= 0; g--)
						for (b = 5; b >= 0; b--)
							out.push(this.getCell_(out, r * 0x33, g * 0x33, b * 0x33, zcls, index++));
				}

				//grayscale
				for (i = 0; i < 16; i++) {
					r = Math.floor((i + i * 16) % 256);
					out.push(this.getCell_(out, r, r, r, zcls, index++));
				}

        		out.push(this.getCell_(out, 255, 255, 255, zcls, index++),
        				 this.getCell_(out, 255, 255, 255, zcls, index++),
        				 '<', tagnm, ' id="', uuid,
        					'-a" tabindex="-1" onclick="return false;" href="javascript:;" class="z-focus-a"></',
        					tagnm, '></div>');
        	},
        	getCell_: function(out, r, g, b, zcls, index) {
				var color = new zkex.inp.Color();
				color.setRGB(r, g, b);

				var hex = color.getHex();
				out.push('<span class="', zcls, '-color" data-color="', hex, '" ',
						'data-index="', index ,'" style="background-color: ', hex,
						';"></span>');
			}
		});

		zss.SSColorbox = zk.$extends(zkex.inp.Colorbox, {
			_zclass: 'zss-colorbox',
			bind_: function () {
				this.$supers(zss.SSColorbox, 'bind_', arguments);
				jq(this.$n('pp')).addClass('zscolorpopup');
			},
			afterCreated_: function() {
				this.$super(zkex.inp.Colorbox, 'afterCreated_');
				this._picker = new zkex.inp.Colorpicker({_wgt: this, _zclass: 'zss-colorpicker'});
				this._palette = new zss.SSColorpalette({_wgt: this});
				this.appendChild(this._picker);
				this.appendChild(this._palette);
			}
		});

		// customized color popup for spreadsheet
		zss.ColorPopup = zk.$extends(zss.SSColorbox, {
				_zclass: 'zss-colorbox',
				_visible: false,
				_ref: null,
				$init: function (ref) {
					this.$supers(zss.ColorPopup, '$init', []);
					this._ref = ref;
				},
				adjustPosition_: function() {
					// adjust popup position to ref. widget
					if(this._ref && this._ref.$n) {
						zk(this.$n('pp')).position(this._ref.$n(), this._getPosition());
					}
				},
				bind_: function () {
					this.$supers(zss.ColorPopup, 'bind_', arguments);
				},
				open: function() {
					this.openPopup();
					this.adjustPosition_();
				},
				openPalette: function() {
					this.$supers(zss.ColorPopup, 'openPalette', arguments);
					this.adjustPosition_();
				},
				openPicker: function() {
					this.$supers(zss.ColorPopup, 'openPicker', arguments);
					this.adjustPosition_();
				},
				shallStackup_: function() {
					return false; // disable stack up
				},
				_syncShadow: function(target) {
					// disable shadow
				},
				_hideShadow: function(target) {
					// disable shadow
				}
			}
		);
		
		zss.ColorbuttonEx = zk.$extends(zss.SSToolbarbutton, {
			_zclass: 'zss-toolbarbutton',
			_color: '#000000', /*default color*/
			$init: function (props, wgt, popupHolder) {
				this.$supers(zss.ColorbuttonEx, '$init', [props]);
				this._wgt = wgt;
				this._colorPopup = new zss.ColorPopup(this);
				this.setPopup(this._colorPopup);
				if(popupHolder) {
					popupHolder.appendChild(this._colorPopup);
				}
			},
			$define: {
				/** Sets the image URI.
				 * @param String image the URI of the image
				 */
				/** Returns the image URI.
				 * <p>Default: null.
				 * @return String
				 */
				image: function (v) {
					var n = this.getImageNode();
					if (n) n.src = v || '';
				},
				/**
				 * Sets the color
				 * @param color in #RRGGBB format (hexdecimal).
				 */
				/**
				 * Returns the color
				 * @return string
				 */
				color: function (hex) {
					var c = this.$n('color');
					if (c)
						c.style.backgroundColor = hex;
				}
			},
			bind_: function () {
				this.$supers(zss.ColorbuttonEx, 'bind_', arguments);

				if(this._colorPopup) {
					this._colorPopup.listen({onChange: this.proxy(this.onChange)});
				}
			},
			unbind_: function () {
				if(this._colorPopup) {
					this._colorPopup.unlisten({onChange: this.proxy(this.onChange)});
				}
				
				this.$supers(zss.ColorbuttonEx, 'unbind_', arguments);
			},
			doKeyDown_: zk.$void,
			doKeyUp_: zk.$void,
			doKeyPress_: zk.$void,
			onChange: function (evt) { //invoke from Color Palette, not from event
				var hex = evt.data.color;
				this.setColor(hex);
				this.fire('onClick');
				var wgt = this._wgt;
				if (wgt) {
					wgt.focus(false);
				}
			},
			domContent_: function () {
				var uuid = this.uuid;
				var cnt = this.$supers(zss.ColorbuttonEx, 'domContent_', arguments);

				var out = new Array();
				out.push(cnt);
				out.push('<div id="' + uuid + '-color" class="zstbtn-color" style="background:' 
					+ this.getColor() + ';"></div>');
				
				return out.join('');
			},
			shallStackup_: function () {
				return false;
			}
		});
	})
}
//ZSS-463, define CE & PE ColorPicker at the same time on purpose
if(true){//ZK CE version
	zss.Colorbutton = zk.$extends(zss.SSToolbarbutton, {
		_zclass: 'zss-toolbarbutton',
		_open: false,
		_color: '#000000', /*default color*/
		$init: function (props, wgt) {
			this.$supers(zss.Colorbutton, '$init', [props]);
			this._wgt = wgt;
		},
		$define: {
			/** Sets the image URI.
			 * @param String image the URI of the image
			 */
			/** Returns the image URI.
			 * <p>Default: null.
			 * @return String
			 */
			image: function (v) {
				var n = this.getImageNode();
				if (n) n.src = v || '';
			},
			/**
			 * Sets the color
			 * @param color in #RRGGBB format (hexdecimal).
			 */
			/**
			 * Returns the color
			 * @return string
			 */
			color: function (hex) {
				var c = this.$n('color');
				if (c)
					c.style.backgroundColor = hex;
			}
		},
		bind_: function () {
			this.$supers(zss.Colorbutton, 'bind_', arguments);
			zWatch.listen({onFloatUp: this});
		},
		unbind_: function () {
			zWatch.unlisten({onFloatUp: this});
			this.$supers(zss.Colorbutton, 'unbind_', arguments);
		},
		onFloatUp: function (ctl) {
			if (!zUtl.isAncestor(this, ctl.origin))
				this.closePopup();
		},
		doMouseOver_: _onCell = function (evt) {
			var target = evt.domTarget,
				scls = this.getSclass();
			if (jq(target).parents('.' + scls + '-pp')[0]) {
				jq(target).parents('.' + scls + '-cell')
				[evt.name == 'onMouseOver' ? 'addClass' : 'removeClass'](scls + '-cell-over');
			} else
				jq(this.$n())[evt.name == 'onMouseOver' ? 'addClass' : 'removeClass'](scls + '-over');
		},
		doMouseOut_: _onCell,
		doClick_: function (evt) {
			var t = evt.domTarget,
				p = this.$n('pp'),
				$t = jq(evt.domTarget),
				scls = this.getSclass();

			if (jq.isAncestor(p, t)) {
				if ($t.attr('class').indexOf(scls + '-cell-cnt') >= 0) {
					var hex = $t.children('i').text();
					
					this.setColor(hex);
					this.fire('onClick');
					this.closePopup();
					$t.parent().removeClass(scls + '-cell-over');	
				}
			} else {
				if (this._open) {
					this.closePopup();
				} else {
					this.openPopup();
				}
			}
		},
		openPopup: function () {
			this._open = true;
			var node = this.$n(),
				pp = this.$n("pp");

			pp.style.position = "absolute";
			pp.style.overflow = "auto";
			pp.style.display = "block";
			pp.style.zIndex = "88000";

			jq(pp).zk.makeVParent();
			zk(pp).position(node, this._getPosition());
		},
		_getPosition: function () {
			var parent = this.parent;
			if (!parent) return;
			if (parent.$instanceof(zul.wgt.Toolbar))
				return 'vertical' == parent.getOrient() ? 'end_before' : 'after_start';
			return 'after_start';
		},
		closePopup: function () {
			this._open = false;
			var node = this.$n(),
				pp = this.$n("pp");
			jq(pp).zk.undoVParent();
		},
		domContent_: function () {
			var uid = this.uuid,
				cnt = this.$supers(zss.Colorbutton, 'domContent_', arguments),
				cols = zss.colorPalette.color,
				width = zss.colorPalette.width,
				height = zss.colorPalette.height,
				colSize = cols.length,
				scls = this.getSclass(),
				color = this.getColor();
			cnt = cnt + '<div id="' + uid + '-color" class="' + this.getSclass() + 
				'-color" style="background:' + this.getColor() + 
				';"></div><div id="' + uid + '-pp" style="display:none;width:'+width+'px;height:'+height+'px;" class="' + scls + '-pp">';
				
			for (var i = 0; i < colSize; i++) {
				cnt += '<div class="' + scls + '-cell"><div style="background: ' + cols[i] + 
					';" class="' + scls + '-cell-cnt"><i style="display: none">' + cols[i] + '</i></div></div>';
			}	
			cnt += '</div>';//Note. use Colorbox's "z-colorbtn-pp"
			return cnt;
		}
	});
}


zss.SSMenu = zk.$extends(zul.menu.Menu, {
	_zclass: 'zss-menu',
	setContent: function (content) {
		if (!content || content.length == 0) return;

		if (!this._contentHandler) {
			if (zk.feature.pe) {
				var self = this;
				zk.load('zkex.inp', null, function () {
					self._contentHandler = new zss.ContentHandler(self, content);
				});
				return;
			}
			this._contentHandler = new zul.menu.ContentHandler(this, content);
		} else
			this._contentHandler.setContent(content);
	},
	setDisabled: function (actions) {
		var pp = this.menupopup;
		if (pp && pp.setDisabled) {
			pp.setDisabled(actions);
		}
	},
	bind_: function () {
		this.$supers(zss.SSMenu, 'bind_', arguments);
		if (this._sclass)
			jq(this.$n('a')).addClass('k-icon-' + this._sclass);
	},
	getSclass: function () {
		return 'zsmenu-' + this._sclass;
	}
});

zss.SSMenuitem = zk.$extends(zul.menu.Menuitem, {
	_zclass: 'zss-menuitem',
	$init: function (props, wgt) {
		this.$supers(zss.SSMenuitem, '$init', [props]);
		this._wgt = wgt;
	},
	$define: {
		/**
		 * Represent button's action at server side
		 */
		$action: null
	},
	//ZSS-1276
	$getAction: function () {
		return this._$aciton || this.$action;
	},
	setDisabled: function (actions) {
		if (jq.isArray(actions)) {
			var d = this.isDisabled();
			if (actions.$contains(this.$getAction())) { //ZSS-1276
				if (!d)
					this.$supers(zss.SSMenuitem, 'setDisabled', [true]);
			} else if (d) {//clear disabled
				this.$supers(zss.SSMenuitem, 'setDisabled', [false]);
			}	
		} else {
			this.$supers(zss.SSMenuitem, 'setDisabled', arguments);
		}
	},
	bind_: function () {
		this.$supers(zss.SSMenuitem, 'bind_', arguments);
		jq(this.$n('a')).addClass('k-icon-' + this.$getAction());
	},
	domContent_: function () {
		var label = '<span class="' + this.$s('text') + '">'
					+ (zUtl.encodeXML(this.getLabel())) + '</span>',
			icon = '<i class="' + this.$s('icon') + ' z-icon-check"></i>',
			img = this.getImage(),
			iconSclass = this.domIcon_();

		if (img)
			img = '<img src="' + img + '" class="' + this.$s('image') + '" align="absmiddle" />'
				+ (iconSclass ? ' ' + iconSclass : '');
		else {
			if (iconSclass) {
				img = iconSclass;
			} else {
				img = '<img ' + (this.isTopmost() ? 'style="display:none"' : '')
					+ ' src="data:image/png;base64,R0lGODlhAQABAIAAAAAAAAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==" class="' + this.$s('image') + '" align="absmiddle" />';
			}
		}
//		return img + (this.isAutocheck() || this.isCheckmark() ? icon : '') + label;
		return img + label;
	},
	getSclass: function () {
		return 'zsmenuitem-' + this.$getAction(); //ZSS-1276
	}
});
zk.copy(zss.SSMenuitem.prototype, AbstractPopupHandler);

zss.StateMenuitem = zk.$extends(zss.SSMenuitem, {
	_zclass: 'zss-menuitem',
	$init: function (props, wgt) {
		this.$supers(zss.StateMenuitem, '$init', [props]);
		this.updateState = props.updateState;
		this._wgt = wgt;
	},
	updateState: null
});

if (zk.feature.pe) {
	zss.ColorMenuEx = zk.$extends(zss.SSMenu, {
		_zclass: 'zss-menu',
		bind_: function () {
			this.$supers(zss.ColorMenuEx, 'bind_', arguments);
			jq(this.$n('cnt-pp')).addClass('zscolorpopup');
			this.listen({'onChange': this});
		},
		unbind_: function () {
			this.unlisten({'onChange': this});
			this.$supers(zss.ColorMenuEx, 'unbind_', arguments);
		},
		getColor: function () {
			return this.color;
		},
		onChange: function (evt) {
			this.color = evt.data.color;
		},
		getSclass: function () {
			return 'zscolormenu';
		}
	});
}

zss.ColorMenu = zk.$extends(zss.SSMenu, {
	_zclass: 'zss-menu',
	_open: false,
	_color: null,
	$define: {
		content: _zkf = function (content) {
			if (!content || content.length == 0) return;
			
			var c = this.$n('img');
			if (c)
				c.style.backgroundColor = content;
			
			if (!this._contentHandler) {
				this._contentHandler = new zss.ColorMenuContentHandler(this, content);
			} else
				this._contentHandler.setContent(content);
		},
		color: _zkf
	},
	bind_: function () {
		this.$supers(zss.ColorMenu, 'bind_', arguments);
		var c = this.$n('img');//can't find img becuase of doesn't has this.desktop
		if (c)
			c.style.backgroundColor = this._color;
		
	},
	unbind_: function () {
		
		this.$supers(zss.ColorMenu, 'unbind_', arguments);
	},
	getSclass: function () {
		return 'zscolormenu';
	},
	getColor: function(){
		return this._color;
	}
});
zk.copy(zss.ColorMenu.prototype, AbstractPopupHandler);

zss.ColorMenuContentHandler = zk.$extends(zk.Widget, {
	_zclass: 'zss-colorMenuContentHandler',
	$init: function(wgt, content) {
		this._wgt = wgt;
		this._content = content;
	 },
	 setContent: function (content) {
	 	if (this._content != content || !this._pp) {
			this._content = content;
			this._wgt.rerender();	
		}
	 },
	 redraw: function (out) {	 
		var wgt = this._wgt,
			uid = wgt.uuid,
			cols = zss.colorPalette.color,
			width = zss.colorPalette.width,
			height = zss.colorPalette.height,
			colSize = cols.length,
			scls = wgt.getSclass(),
			color = this._content;
		var cnt = '<div id="' + uid + '-cnt-pp" style="display:none;width:'+width+'px;height:'+height+'px;" class="' + scls + '-cnt-pp">';
			
		for (var i = 0; i < colSize; i++) {
			cnt += '<div class="' + scls + '-cell"><div style="background: ' + cols[i] + 
				';" class="' + scls + '-cell-cnt"><i style="display: none">' + cols[i] + '</i></div></div>';
		}	
		cnt += '</div>';//Note. use Colorbox's "z-colorbtn-pp"
		
		out.push(cnt);
		 
	 },
	 bind: function () {
	 	var wgt = this._wgt;
	 	if (!wgt.menupopup) {
			wgt.domListen_(wgt.$n(), 'onClick', 'onShow');
			zWatch.listen({onFloatUp: wgt, onHide: wgt});
		}
		
	 	this._pp = jq('#' + wgt.uuid + '-' + 'cnt-pp')[0];
	 	wgt.domListen_(this._pp, 'onClick', this.proxy(this._onPaletteClick));
	 },
	 unbind: function () {
	 	var wgt = this._wgt;
	 	if (!wgt.menupopup) {
			if (this._shadow) {
				this._shadow.destroy();
				this._shadow = null;
			}
			wgt.domUnlisten_(wgt.$n(), 'onClick', 'onShow');
			zWatch.unlisten({onFloatUp: wgt, onHide: wgt});
		}
	 	
	 	wgt.domUnlisten_(this._pp, 'onClick', this.proxy(this._onPaletteClick));
	 	
		this._pp = null;
	 },
	 isOpen: function () {
		 var pp = this._pp;
		 return (pp && zk(pp).isVisible());
	 },
	 onShow: function () {
	 	var wgt = this._wgt,
			pp = this._pp;
		if (!pp) return;
			
		pp.style.position = "absolute";
		pp.style.overflow = "auto";
		pp.style.display = "block";
		pp.style.zIndex = "88000";
			
		jq(pp).zk.makeVParent();
		zWatch.fireDown("onVParent", this);
			zk(pp).position(wgt.$n(), this.getPosition());
		this.syncShadow();
	 },
	 onHide: function () {
		var pp = this._pp;
		if (!pp || !zk(pp).isVisible()) return;
			pp.style.display = "none";
		jq(pp).zk.undoVParent();
		zWatch.fireDown("onVParent", this);
		this.hideShadow();
	 },
	 onFloatUp: function (ctl) {
		if (!zUtl.isAncestor(this._wgt, ctl.origin))
			this.onHide();
	 },
	 syncShadow: function () {
	 	if (!this._shadow)
			this._shadow = new zk.eff.Shadow(this._wgt.$n("cnt-pp"), {stackup:(zk.useStackup === undefined ? zk.ie6_: zk.useStackup)});
		this._shadow.sync();
	 },
	 hideShadow: function () {
	 	this._shadow.hide();
	 },
	 destroy: function () {
	 	this._wgt.rerender();
	 },
	 getPosition: function () {
	 	var wgt = this._wgt;
		if (wgt.isTopmost()) {
			var bar = wgt.getMenubar();
			if (bar)
				return 'vertical' == bar.getOrient() ? 'end_before' : 'after_start';
		}
		return 'end_before';
	},
	closePalette: function (close) {
	 	var pp = this._pp;
		if (!pp || !zk(pp).isVisible()) return;

		pp.style.display = "none";
		if (close)
			zWatch.fire('onFloatUp', null);
	},
	_onPaletteClick : function(evt){
		var t = evt.domTarget,
			wgt = this._wgt,
			p = this._pp,
			$t = jq(evt.domTarget),
			scls = wgt.getSclass();

		if (jq.isAncestor(p, t)) {
			if ($t.attr('class').indexOf(scls + '-cell-cnt') >= 0) {
				var hex = $t.children('i').text();
				this.closePalette(true);
				this._wgt.setColor(hex);
				evt.stop();
			}
		}
	}
});

zss.SSMenupopup = zk.$extends(zul.menu.Menupopup, {
	_zclass: 'zss-menupopup',
	$init: function (wgt) {
		this.$supers(zss.SSMenupopup, '$init', []);
		this._wgt = wgt;
		this.z$rod = false; //ZSS-658 turn off ZK EE ROD to avoid only rendering a div
	},
	setDisabled: function (actions) {
		var chd = this.firstChild;
		for (;chd; chd = chd.nextSibling) {
			if (!chd.setDisabled) {//Menuseparator
				continue;
			}
			
			chd.setDisabled(actions);
		}
	},
	open: function () {
		this.$supers(zss.SSMenupopup, 'open', arguments);
		this.$n().style.top = jq.px(parseInt(this.$n().style.top) - 5);
		var wgt = this._wgt;
		if (wgt) {//fake focus
			wgt.focus(false);
		}
	},
	onFloatUp: function (ctl) {
		// ZSS-654: there are dual popup menu, so they will trigger each other's onFloatUp() cause them both be disappeared
		if (!this.isVisible()) {
			return;
		}
		
		if(this._wgt && this.isOpen() && zUtl.isAncestor(ctl.origin, this)) {
			return;
		}
		
		this.$supers(zss.SSMenupopup, 'onFloatUp', arguments);
	},
	zsync: function () {
		// skip shadow
	},
	getSclass: function () {
    	return 'zsmenupopup';
	}
}, {
	_rmActive: function (wgt) {
		if (wgt.parent.$instanceof(zul.menu.Menu)) {
			wgt.parent.$class._rmActive(wgt.parent);
		} else if (wgt.parent.$instanceof(zss.SSToolbarbutton)) {
			wgt.parent.$class._rmActive(wgt.parent);
		}
	}
});

// same as zss.Menupopup except refresh item whether shown or hidden when open
zss.StateMenupopup = zk.$extends(zss.SSMenupopup, {
	_zclass: 'zss-menupopup',
	updateItemState: function(info) {
		var child = this.firstChild;
		for(;child; child = child.nextSibling) {
			if(child.updateState)
				child.updateState.call(child, info);
		}
	}
});
	// same as newActionMenuitem except creating zss.StateMenuitem
	function newActionStateMenuitem(wgt, action, image, updateStateFunc) {
		return new zss.StateMenuitem({
			$action: action,
			image: image ? zk.ajaxURI(image, {au: true}) : null,
			label: msgzss.action[action],
			onClick: function () {
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var s = sheet.getLastSelection(),
						tRow = s.top,
						lCol = s.left,
						bRow = s.bottom,
						rCol = s.right,
						selType = sheet.selType ? sheet.selType : zss.SEL.CELL; //ZSS-717
					sheet.triggerSelection(tRow, lCol, bRow, rCol);
					wgt.fireToolbarAction(action, {tRow: tRow, lCol: lCol, bRow: bRow, rCol: rCol, type: selType}); //ZSS-717
				}
			},
			updateState: updateStateFunc
		},wgt);
	}

	function newActionMenuitem(wgt, action, image, icon) {
		return new zss.SSMenuitem({
			$action: action,
			image: image ? zk.ajaxURI(image, {au: true}) : null,
			label: msgzss.action[action],
			onClick: function () {
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var s = sheet.getLastSelection(),
						tRow = s.top,
						lCol = s.left,
						bRow = s.bottom,
						rCol = s.right,
						selType = sheet.selType ? sheet.selType : zss.SEL.CELL; //ZSS-717
					sheet.triggerSelection(tRow, lCol, bRow, rCol);
					wgt.fireToolbarAction(action, {tRow: tRow, lCol: lCol, bRow: bRow, rCol: rCol, type: selType}); //ZSS-717
				}
			}
		},wgt);
	}

	function triggerByMenupopup (menupopup, widget, testActiveElement) {
		return menupopup && menupopup.isOpen() && (zUtl.isAncestor(menupopup, widget) ||
				// ZSS-654: IE11 and IE9 would focus tag in menupopup
				(testActiveElement && jq.isAncestor(menupopup.$n(), document.activeElement)));
	}
	
zss.StylePanel = zk.$extends(zul.wgt.Popup, {
	_zclass: 'zss-popup',
	$init: function (wgt) {
		this.$supers(zss.StylePanel, '$init', []);
		if (zk.ie6_)
			this.setWidth('186px');
		this._wgt = wgt;
		var styleContainer = new zul.wgt.Div({sclass: 'zsstylepanel-upper', _zclass: 'zss-div'});
		this._upperToolbar = new zss.KToolbar(wgt, new zss.ButtonBuilder(wgt, this).addAll(['fontFamily', 'fontSize', 'fontBold', 'fontItalic']).build());
		this.appendChild(styleContainer);
		
		wgt.listen({onAuxAction: this.proxy(this._closeStylePanel)});
		this._lowerToolbar = new zss.KToolbar(wgt, new zss.ButtonBuilder(wgt, this).addAll(['fontColor', 'backColor', 'border', 'verticalAlign', 'horizontalAlign','wrapText']).build());
		this._styleContainer = styleContainer;
		
		this._menuContainer = new zul.wgt.Div({sclass: 'zsstylepanel-menu', _zclass: 'zss-div'});
		this.appendChild(this._menuContainer); // The 3rd child is menu container
	},
	getMenuContainer: function() {
		return this._menuContainer;
	},
	getStyleContainer: function() {
		return this._styleContainer;
	},
	setDisabled: function (actions) {
		for (var n = this.firstChild; n; n = n.nextSibling) {//toolbars
			for (var chd = n.firstChild;chd; chd = chd.nextSibling) {//buttons
				if (!chd.setDisabled) {
					continue;
				}
				chd.setDisabled(actions);
			}
		}
		this._upperToolbar.setDisabled(actions);
		this._lowerToolbar.setDisabled(actions);
	},
	_closeStylePanel: function () {
		this.close({sendOnOpen:true});
		this._wgt.focus(true);
	},
	bind_: function () {
		this.$supers(zss.StylePanel, 'bind_', arguments);
		this._styleContainer.$n().appendChild(this._upperToolbar.render());
		this._styleContainer.$n().appendChild(this._lowerToolbar.render());
		this._upperToolbar.bind();
		this._lowerToolbar.bind();
	},
	onFloatUp: function (ctl, opt) {
		if (!this.isVisible()) {
			return;
		}

		var origin = ctl.origin,
			sheet = this._wgt.sheetCtrl;

		if (sheet) {
			// ZSS-607: close panel when click outside style popup or menu popup
			if (zk.ie < 11 && origin == this) {
				this._closeStylePanel();
			}
			var menupopups = [sheet.getCellMenupopup(), sheet.getColumnHeaderMenupopup(), sheet.getRowHeaderMenupopup()];
			for (var i = menupopups.length - 1; i >= 0; i--) {
				if (triggerByMenupopup(menupopups[i], origin, zk.ie && opt && opt.triggerByFocus)) {
					return;
				}
			}
		}
		
		this.$supers(zss.StylePanel, 'onFloatUp', arguments);
	},
	getSclass: function () {
		return 'zsstylepanel';
	},
	// ZSS-383: turn off stack-up
	shallStackup_: function () {
		return false;
	}
});
	
zss.MenupopupFactory = zk.$extends(zk.Object, {
	$init: function (wgt) {
		this._wgt = wgt;
	},
	/**
	 * Returns a newly-created paste menupopup
	 */
	paste: function () {
		return new zss.KMenupopup(this._wgt, 'paste', ['paste', 'pasteFormula', 'pasteValue', 'pasteAllExceptBorder', 'pasteTranspose', 'pasteSpecial']);
	},
	/**
	 * Return a newly-created border menupopup
	 * @return zul.menu.Menupopup
	 */
	border: function () {
		let wgt = this._wgt,
			pp = new zss.KMenupopup(wgt, 'border',
				['borderBottom', 'borderTop', 'borderLeft', 'borderRight', 'borderNo', 'borderAll', 'borderOutside', 'borderInside', 'borderInsideHorizontal', 'borderInsideVertical']);
		let colorItem = new zss.KMenuitem(wgt, 'borderColor', null, 'border');
		let colorPp = new zss.KMenupopup(wgt, 'borderColor');
		colorItem.setPopup(colorPp);
		pp.appendChild(colorItem);
		return pp;
	},
	verticalAlign: function () {
		return new zss.KMenupopup(this._wgt, 'verticalAlign', ['verticalAlignTop', 'verticalAlignMiddle', 'verticalAlignBottom']);
	},
	horizontalAlign: function () {
		return new zss.KMenupopup(this._wgt, 'horizontalAlign', ['horizontalAlignLeft', 'horizontalAlignCenter', 'horizontalAlignRight']);
	},
	mergeAndCenter: function () {
		return new zss.KMenupopup(this._wgt, 'mergeAndCenter', ['mergeAndCenter', 'mergeAcross', 'mergeCell', 'unmergeCell']);
	},
	insert: function () {
		var wgt = this._wgt,
			pp = new zss.KMenupopup(wgt, 'insert');

		let subpp = new zss.KMenupopup(wgt, 'insertCell');
		subpp.appendChild(new zss.KMenuitem(wgt, 'shiftCellRight'));
		subpp.appendChild(new zss.KMenuitem(wgt, 'shiftCellDown'));
		let ppItem = new zss.KMenuitem(wgt, 'insertCell');
		ppItem.setPopup(subpp);
		pp.appendChild(ppItem);
		pp.appendChild(new zss.KMenuitem(wgt, 'insertSheetRow'));
		pp.appendChild(new zss.KMenuitem(wgt, 'insertSheetColumn'));
		return pp;
	},
	del: function () {
		let wgt = this._wgt,
			pp = new zss.KMenupopup(wgt, 'del');

		let subpp = new zss.KMenupopup(wgt, 'deleteCell');
		subpp.appendChild(new zss.KMenuitem(wgt, 'shiftCellLeft'));
		subpp.appendChild(new zss.KMenuitem(wgt, 'shiftCellUp'));
		let ppItem = new zss.KMenuitem(wgt, 'deleteCell');
		ppItem.setPopup(subpp);
		pp.appendChild(ppItem);
		pp.appendChild(new zss.KMenuitem(wgt, 'deleteSheetRow'));
		pp.appendChild(new zss.KMenuitem(wgt, 'deleteSheetColumn'));
		return pp;
	},
	//TODO
	format: function () {
		
	},
	autoSum: function () {
//		var wgt = this._wgt,
//			p = new zss.KMenupopup(wgt, 'autoSum', ['autoSum', 'average', 'countNumber', 'max', 'min', 'moreFunction']);
//
//		return p;
	},
	clear: function () {
		let p = new zss.KMenupopup(this._wgt, 'clear', ['clearContent', 'clearStyle', 'clearAll']);
		return p;
	},
	sortAndFilter: function () {
		let p = new zss.KMenupopup(this._wgt, 'sortAndFilter', ['sortAscending', 'sortDescending', 'customSort', 'filter', 'clearFilter', 'reapplyFilter']);
		return p;
	},
	insertChart: function () {
		let wgt = this._wgt,
			pp = new zss.KMenupopup(wgt, 'insertChart');

		let type = 'columnChart';
		let item0 = new zss.KMenuitem(wgt, type);
		let subpp0 = new zss.KMenupopup(wgt, type, [type, type + '3D']);
		item0.setPopup(subpp0);
		type = 'lineChart';
		let item1 = new zss.KMenuitem(wgt, type);
		let subpp1 = new zss.KMenupopup(wgt, type, [type, type + '3D']);
		item1.setPopup(subpp1);
		type = 'pieChart';
		let item2 = new zss.KMenuitem(wgt, type);
		let subpp2 = new zss.KMenupopup(wgt, type, [type, type + '3D']);
		item2.setPopup(subpp2);
		type = 'barChart';
		let item3 = new zss.KMenuitem(wgt, type);
		let subpp3 = new zss.KMenupopup(wgt, type, [type, type + '3D']);
		item3.setPopup(subpp3);
		let item4 = new zss.KMenuitem(wgt, 'areaChart');
		let item5 = new zss.KMenuitem(wgt, 'scatterChart');
		type = 'otherChart';
		let item6 = new zss.KMenuitem(wgt, type);
		let subpp6 = new zss.KMenupopup(wgt, type, ['doughnutChart']);
		item6.setPopup(subpp6);
		pp.appendChild(item0);
		pp.appendChild(item1);
		pp.appendChild(item2);
		pp.appendChild(item3);
		pp.appendChild(item4);
		pp.appendChild(item5);
		pp.appendChild(item6);

		return pp;
	},
//	columnChart: function () {
//		var wgt = this._wgt,
//			p = new zss.SSMenupopup();
//
//		return p;
//	},
//	lineChart: function () {
//		var wgt = this._wgt,
//			p = new zss.SSMenupopup();
//
//		p.appendChild(newActionMenuitem(wgt, 'lineChart'));
//		p.appendChild(newActionMenuitem(wgt, 'lineChart3D'));
//		return p;
//	},
//	pieChart: function () {
//		var wgt = this._wgt,
//			p = new zss.SSMenupopup();
//
//		p.appendChild(newActionMenuitem(wgt, 'pieChart'));
//		p.appendChild(newActionMenuitem(wgt, 'pieChart3D'));
//		return p;
//	},
//	barChart: function () {
//		var wgt = this._wgt,
//			p = new zss.SSMenupopup();
//
//		p.appendChild(newActionMenuitem(wgt, 'barChart'));
//		p.appendChild(newActionMenuitem(wgt, 'barChart3D'));
//		return p;
//	},
//	otherChart: function () {
//		var wgt = this._wgt,
//			p = new zss.SSMenupopup();
//		p.appendChild(newActionMenuitem(wgt, 'doughnutChart'));
//		return p;
//	},
	rowHeader: function () {
		var wgt = this._wgt,
			p = new zss.SSMenupopup(wgt);
		p.appendChild(newActionMenuitem(wgt, 'cut'));
		p.appendChild(newActionMenuitem(wgt, 'copy'));
		p.appendChild(newActionMenuitem(wgt, 'paste'));
		p.appendChild(newActionMenuitem(wgt, 'pasteSpecial'));
		p.appendChild(new zul.menu.Menuseparator({_zclass: 'zss-menuseparator'}));
		
		p.appendChild(newActionMenuitem(wgt, 'insertSheetRow'));
		p.appendChild(newActionMenuitem(wgt, 'deleteSheetRow'));
		p.appendChild(newActionMenuitem(wgt, 'clearContent'));
		p.appendChild(new zul.menu.Menuseparator({_zclass: 'zss-menuseparator'}));
		
		p.appendChild(newActionMenuitem(wgt, 'formatCell'));
		p.appendChild(newActionMenuitem(wgt, 'dataValidation'));
		p.appendChild(newActionMenuitem(wgt, 'rowHeight'));
		p.appendChild(newActionMenuitem(wgt, 'hideRow'));
		p.appendChild(newActionMenuitem(wgt, 'unhideRow'));
		
		return p;
	},
	columnHeader: function () {
		var wgt = this._wgt,
			p = new zss.SSMenupopup(wgt);
		p.appendChild(newActionMenuitem(wgt, 'cut'));
		p.appendChild(newActionMenuitem(wgt, 'copy'));
		p.appendChild(newActionMenuitem(wgt, 'paste'));
		p.appendChild(newActionMenuitem(wgt, 'pasteSpecial'));
		p.appendChild(new zul.menu.Menuseparator({_zclass: 'zss-menuseparator'}));
		
		p.appendChild(newActionMenuitem(wgt, 'insertSheetColumn'));
		p.appendChild(newActionMenuitem(wgt, 'deleteSheetColumn'));
		p.appendChild(newActionMenuitem(wgt, 'clearContent'));
		p.appendChild(new zul.menu.Menuseparator({_zclass: 'zss-menuseparator'}));
		
		p.appendChild(newActionMenuitem(wgt, 'formatCell'));
		p.appendChild(newActionMenuitem(wgt, 'dataValidation'));
		p.appendChild(newActionMenuitem(wgt, 'columnWidth'));
		p.appendChild(newActionMenuitem(wgt, 'hideColumn'));
		p.appendChild(newActionMenuitem(wgt, 'unhideColumn'));
		
		return p;
	},
	cell: function () {
		var wgt = this._wgt,
			p = new zss.StateMenupopup(wgt),
			insertMenu = new zss.SSMenu({
				label: msgzss.action.insert,
				sclass: 'insert'
			}),
			insertMP = new zss.SSMenupopup(),
			deleteMenu = new zss.SSMenu({
				label: msgzss.action.del,
				sclass: 'del'
			}),
			deleteMP = new zss.SSMenupopup(),
			filterMenu = new zss.SSMenu({
				label: msgzss.action.filter,
				sclass: 'filter'
			}),
			filterMP = new zss.SSMenupopup(),
			sortMenu = new zss.SSMenu({
				label: msgzss.action.sort,
				sclass: 'sort'
			}),
			sortMP = new zss.SSMenupopup();
		p.appendChild(newActionMenuitem(wgt, 'cut'));
		p.appendChild(newActionMenuitem(wgt, 'copy'));
		p.appendChild(newActionMenuitem(wgt, 'paste'));
		p.appendChild(newActionMenuitem(wgt, 'pasteSpecial'));
		p.appendChild(new zul.menu.Menuseparator({_zclass: 'zss-menuseparator'}));
		
		insertMP.appendChild(newActionMenuitem(wgt, 'shiftCellRight'));
		insertMP.appendChild(newActionMenuitem(wgt, 'shiftCellDown'));
		insertMP.appendChild(newActionMenuitem(wgt, 'insertSheetRow'));
		insertMP.appendChild(newActionMenuitem(wgt, 'insertSheetColumn'));
		insertMenu.appendChild(insertMP);
		p.appendChild(insertMenu);
		
		deleteMP.appendChild(newActionMenuitem(wgt, 'shiftCellLeft'));
		deleteMP.appendChild(newActionMenuitem(wgt, 'shiftCellUp'));
		deleteMP.appendChild(newActionMenuitem(wgt, 'deleteSheetRow'));
		deleteMP.appendChild(newActionMenuitem(wgt, 'deleteSheetColumn'));
		deleteMenu.appendChild(deleteMP);
		p.appendChild(deleteMenu);
		
		p.appendChild(newActionMenuitem(wgt, 'clearContent'));
		p.appendChild(new zul.menu.Menuseparator({_zclass: 'zss-menuseparator'}));
		
		filterMP.appendChild(newActionMenuitem(wgt, 'reapplyFilter'));
		filterMP.appendChild(newActionMenuitem(wgt, 'filter'));
		filterMenu.appendChild(filterMP);
		p.appendChild(filterMenu);
		
		sortMP.appendChild(newActionMenuitem(wgt, 'sortAscending'));
		sortMP.appendChild(newActionMenuitem(wgt, 'sortDescending'));
		sortMP.appendChild(newActionMenuitem(wgt, 'customSort'));
		sortMenu.appendChild(sortMP);
		p.appendChild(sortMenu);
		p.appendChild(new zul.menu.Menuseparator({_zclass: 'zss-menuseparator'}));

		function getCellByXY(info) {
			var pageX = info.pageX,
				pageY = info.pageY,
				sheet = info.sheet,
				position = zss.SSheetCtrl._calCellPos(sheet, pageX, pageY);
			return sheet.getCell(position[0], position[1]);
		}
		p.appendChild(newActionStateMenuitem(wgt, 'insertComment', null, 
			function(info){
				this.setVisible(!getCellByXY(info).comment)}));
		p.appendChild(newActionStateMenuitem(wgt, 'editComment', null, 
			function(info){
				this.setVisible(getCellByXY(info).comment)}));
		p.appendChild(newActionStateMenuitem(wgt, 'deleteComment', null, 
			function(info){
				this.setVisible(getCellByXY(info).comment)}));
		p.appendChild(new zul.menu.Menuseparator({_zclass: 'zss-menuseparator'}));
		
		p.appendChild(newActionMenuitem(wgt, 'formatCell'));
		p.appendChild(newActionMenuitem(wgt, 'dataValidation'));
		p.appendChild(newActionMenuitem(wgt, 'hyperlink'));
		p.appendChild(newActionMenuitem(wgt, 'richTextEdit'));
		return p;
	},
	style: function () {
		return new zss.StylePanel(this._wgt);
	}
});

zss.Buttons = zk.$extends(zk.Object, {
}, {//static
	 HOME_DEFAULT: ['newBook', 'saveBook', 'exportPDF', 'separator',
	           'paste', 'cut', 'copy',
	           'fontFamily', 'fontSize',
	           'fontBold', 'fontItalic', 'fontUnderline', 'fontStrike',
	           'border', 'fontColor', 'backColor',
	           'verticalAlign', 'horizontalAlign', 'textIndentDecrease', 'textIndentIncrease',
	           'wrapText', 'mergeAndCenter', 'insert', 'del',
	           'clear', 'sortAndFilter',
	           'protectSheet', 'gridlines',
	           'insertPicture', 'insertChart', 'hyperlink'
	           ],
	 INSERT_DEFAULT: ['insertPicture', 'separator',
	                  'columnChart', 'lineChart', 'pieChart', 
	                  'barChart', 'areaChart', 'scatterChart', 
	                  'otherChart', 'separator',
	                  'hyperlink'],
	 FORMULA_DEFAULT: ['insertFunction', 'autoSum', 'financial', 
	                   'logical', 'text', 'dateAndTime', 
	                   'lookupAndReference', 'mathAndTrig', 'moreFunction']
});

zss.TooltipPopup = zk.$extends(zul.wgt.Popup, {
	_zclass: 'zss-popup',
	bind_: function() {
		this.$supers(zss.TooltipPopup, 'bind_', arguments);
		jq(this.$n()).append('<div id="' + this.uuid + '-pt" class="zss-tooltip-pointer"></div>');
	},
	open: function (ref, offset, position, opts) {
		this.$supers(zss.TooltipPopup, 'open', [ref, offset, 'after_center', opts]);
		var pt = this.$n('pt');
		zk(pt).position(ref.$n(), 'after_center');
		pt.style.top = '-6px';
		this.$n().style.zIndex = '1799';
	},
	getSclass: function () {
		return 'zsttpp';
	}
});
	function newActionToolbarbutton(wgt, action, image, data, labelOnly, icon) {
		data = data || {};
		var label = data.label == null ? msgzss.action[action] : data.label;
		var tooltip = data.tooltip || label;
		var pptt = new zss.TooltipPopup({id: action + '-tooltip'});
		pptt.appendChild(new zul.wgt.Label({_zclass: 'zss-label', value: tooltip}));
		return [new zss.SSToolbarbutton({
			$action: action,
			label: labelOnly ? label : null,
			iconSclass: data.iconSclass || (icon ? icon : null),
			image: data.iconURI || (image ? zk.ajaxURI(image, {au: true}) : null),
			tooltip: action + '-tooltip, delay=0',
			onClick: function () {
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var s = sheet.getLastSelection(),
						tRow = s.top,
						lCol = s.left,
						bRow = s.bottom,
						rCol = s.right,
						selType = sheet.selType ? sheet.selType : zss.SEL.CELL; //ZSS-717

					sheet.triggerSelection(tRow, lCol, bRow, rCol);
					wgt.fireToolbarAction(action, {tRow: tRow, lCol: lCol, bRow: bRow, rCol: rCol, type: selType}); //ZSS-717
				} else {
					wgt.fireToolbarAction(action, {tRow: -1, lCol: -1, bRow: -1, rCol: -1, type: zss.SEL.ALL});  //ZSS-717
				}
			}
		}, wgt), pptt];
	}

	function newKActionToolbarbutton(builder, className, data) {
		return new zss.KToolbarButton(builder, className, data || {});
	}
	
	/**
	 * return ColorPicker's construction function upon user configurations under PE
	 */
	function getColorButtonConstructor(spreadsheet){
		return (!!zss.ColorbuttonEx && spreadsheet.getColorPickerExUsed()) ? zss.ColorbuttonEx : zss.Colorbutton;
	}
	
zss.ButtonBuilder = zk.$extends(zk.Object, {
	/**
	 * @param zss.Spreadsheet
	 */
	$init: function (wgt, popupHolder, showTooltip) {
		this._wgt = wgt;
		this._popupHodler = popupHolder;
		this._showTooltip = showTooltip;
		this.contents = [];
	},
	applyHolder: function (popup) {
//		if(this._popupHodler) {
//			this._popupHodler.appendChild(popup);
//		}
		return popup;
	},
	/**
	 * @param String
	 */
	add: function (element) {
		this.contents.push(element);
		return this;
	},
	/**
	 * @param String array
	 */
	addAll: function (elements) {
		var cts = this.contents;
		for (var i = 0, len = elements.length; i < len; i++) {
			cts.push(elements[i]);
		}
		return this;
	},
	/**
	 * Returns a newly-created buttons
	 */
	build: function () {
		var btns = [],
			cts = this.contents;
		while (fn = cts.shift()) {
			var btn = (this[fn.key || fn] || this.$custom).apply(this, [fn]);
			if (btn instanceof Array && btn.length > 1) {
				btns.push(btn[0]);
				btns.push(btn[1]);
			} else {
				btns.push(btn);
			}
		}
		return btns;
	},
	$custom: function (data) {
		data = data || {};

		if (data.templateURI) {
		 	var container = new zss.KToolbarCustomButton(this, data);
		 	var spreadsheet = this._wgt;
			getScript(data.templateURI, function (script) {
				var func = jq.evalJSON(script);
				var isBound = false,
					fn0 = function () {
						if (isBound) return;
						isBound = true;
						func.apply(container, [spreadsheet, data]);
					},
					fn1 = function () {
						isBound = false;
					},
					init;
				container.afterBind = fn0;
				container.afterUnbind = fn1;
				if (container.wgt.desktop) {
					fn0();
					container.afterBind = undefined;
				}
			});
			return container;
		} else {
			data['custom'] = true;
			return newKActionToolbarbutton(this, data.key, data);
		}
	},
	/**
	 * @return zss.ToolbarbuttonSeparator
	 */
	separator: function (data) {
		return new zss.KToolbarSeparator();
	},
	/**
	 * Create new book button
	 * @return zss.SSToolbarbutton
	 */
	newBook: function (data) {
		return newKActionToolbarbutton(this, 'newBook');
	},
	/**
	 * Create save book button 
	 * @return zss.SSToolbarbutton
	 */
	saveBook: function (data) {
		return newKActionToolbarbutton(this, 'saveBook');
	},
	/**
	 * Create export PDF button
	 * @return zss.SSToolbarbutton
	 */
	exportPDF: function (data) {
		return newKActionToolbarbutton(this, 'exportPDF');
	},
	paste: function (data) {
		let wgt = this._wgt,
			btn = newKActionToolbarbutton(this, 'paste');
		btn.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).paste()));
		return btn;
	},
	cut: function (data) {
		return newKActionToolbarbutton(this, 'cut');
	},
	copy: function (data) {
		return newKActionToolbarbutton(this, 'copy');
	},
	fontFamily: function (data) {
		const wgt = this._wgt;
		const btn = new zss.KToolbarCombobox(this, 'fontFamily', {getterFunction: 'getFontName'});
		let options = ['Calibri', 'Arial', 'Arial Black', 'Comic Sans MS', 'Courier New', 'Georgia', 'Impact',
			'Lucida Console', 'Lucida Sans Unicode', 'Palatino Linotype', 'Tahoma', 'Times New Roman',
			'Trebuchet MS', 'Verdana', 'MS Sans Serif', 'MS Serif'];
		if (wgt._customFontFamily) {
			options = options.concat(wgt._customFontFamily);
		}
		const menupopup = new zss.KMenupopup(wgt, 'fontFamily', options, 'kfont');
		const items = menupopup.items;
		for (let i = 0; i < items.length; i++) {
			items[i].fireToolbarAction = function (action, props) {
				props['name'] = action;
				wgt.fireToolbarAction('fontFamily', props);
			}
		}
		btn.setPopup(menupopup);
		return btn;
	},
	fontSize: function (data) {
		let wgt = this._wgt,
			btn = new zss.KToolbarCombobox(this, 'fontSize'),
			menupopup = new zss.KMenupopup(wgt, 'fontSize',
				['8', '9', '10', '11', '12', '14', '16',
				'18', '20', '22', '24', '26', '28',
				'36', '48', '72']);
		let items = menupopup.items;
		for (let i = 0; i < items.length; i++) {
			items[i].fireToolbarAction = function (action, props) {
				props['size'] = action;
				wgt.fireToolbarAction('fontSize', props);
			}
		}
		btn.setPopup(menupopup);
		return btn;
	},
	//ZSS-1171: no toolbar or no context menu
	_skipNoShow: function () {
		return (this.isStylePanel && !this._wgt.isShowContextMenu())
		|| (this.isToolbar && !this._wgt.getShowToolbar());
	},
	//ZSS-1171: no need to precess the event
	_skipEvent: function (evt, b) {
		if (this._skipNoShow()) {
			return true;
		}
		if (evt.name == 'onCellSelection') {
			var d = evt.data;
			// same cell, skip
			if (d.top == b.preRow && d.left == b.preCol) {
				return true;
			}
			b.preRow = d.top;
			b.preCol = d.left;
			return false;
		} else if (evt.name == 'onCellUpdate') {
			var d = evt.data;
			// not on the selected cell, skip
			return (d.top != b.preRow || d.left != b.preCol);
		}
		// not the event concerned, skip
		return true;
	},
	fontBold: function (data) {
		var wgt = this._wgt,
			fn = function (evt) {
				//ZSS-1171
				if (bd._skipEvent(evt, btn)) {
					return;
				}
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var d = evt.data,
						c = sheet.getCell(d.top, d.left);
					if (c) {
						btn.setSelectedEffect(c.isFontBold());
					}
				}
			}
			btn = newKActionToolbarbutton(this, 'fontBold', {updateBtn: true});
		return btn;
	},
	fontItalic: function (data) {
		return newKActionToolbarbutton(this, 'fontItalic', {updateBtn: true});
	},
	fontUnderline: function (data) {
		return newKActionToolbarbutton(this, 'fontUnderline', {updateBtn: true});
	},
	fontStrike: function (data) {
		return newKActionToolbarbutton(this, 'fontStrike', {updateBtn: true, getterFunction: 'isFontStrikeout'});
	},
	border: function (data) {
		let wgt = this._wgt,
			btn = newKActionToolbarbutton(this, 'border'),
			pp = this.applyHolder(new zss.MenupopupFactory(wgt).border()),
			ppItems = pp.items,
			colorItem = ppItems[ppItems.length - 1];
		var colorPicker;
		for (let i = 0; i < ppItems.length; i++) {
			if (i == ppItems.length - 1) {
				break;
			}
			ppItems[i].fireToolbarAction = function (action, props) {
				props['color'] = colorPicker.picker.color.toHexString();
				wgt.fireToolbarAction(action, props);
			};
		}
		colorItem.afterBind = function () {
			const color = jq('<div/>', {class: 'color', style: 'background-color: #000000'});
			jq(colorItem.element).prepend(color);
		};
		btn.setPopup(pp);
		// KEIKAI-200: lazy loading color picker
		btn.afterBind = function () {
			jq(btn.dropdownButton).on('mousedown', function (evt) {
				if (!colorPicker) {
					colorPicker = new zss.Colorpicker(this, 'borderColor', btn);
					colorItem.getPopup().appendChild(colorPicker);
					colorPicker.render();
					colorPicker.bind();
					colorPicker.picker.setValue('#000000');
				}
			});
		};
		return btn;
	},
	componentToHex: function (c) {
		let hex = parseInt(c).toString(16);
		return hex.length == 1 ? "0" + hex : hex;
	},
	rgbToHex: function (rgbString) {
		let rgb = rgbString.split('(')[1].split(')')[0].split(',');
		return "#" + this.componentToHex(rgb[0]) + this.componentToHex(rgb[1]) + this.componentToHex(rgb[2]);
	},
	backColor: function (data) {
		let self = this;
		let wgt = self._wgt;
		let pp = new zss.KMenupopup(wgt, 'backColor');
		let btn = newKActionToolbarbutton(this, 'backColor', {skipAction: true});
		var colorPicker;
		btn.setPopup(pp);
		pp.afterBind = function () {
			btn.inner.appendChild(jq('<div/>', {class: 'color', style: 'background-color: #e7e6e6'})[0]);
		};
		btn.afterBind = function () {
			let jqBtnInner = jq(btn.inner);
			jqBtnInner.on('click', function (evt) {
				let hexColor = self.rgbToHex(jqBtnInner.find('.color').css('backgroundColor'));
				let sht = wgt.sheetCtrl;
				if (sht) {
					wgt.fireToolbarAction('backColor', {color: hexColor, selection: sht._getToolBarSelectionData()}); //ZSS-717
				}
			});
			jq(btn.dropdownButton).on('mousedown', function (evt) {
				// KEIKAI-200: lazy loading color picker
				if (!colorPicker) {
					colorPicker = new zss.Colorpicker(self, 'backColor', btn);
					pp.appendChild(colorPicker);
					colorPicker.render();
					colorPicker.bind();
				}
				const picker = colorPicker.picker;
				let color;
				const sht = wgt.sheetCtrl;
				if (sht) {
					const pos = sht.getLastFocus();
					if (pos) {
						const cell = sht.getCell(pos.row, pos.column);
						color = cell.comp.style.backgroundColor;
					}
				}
				picker.setValue(color || '#ffffff');
				const hex = picker.color.toHexString();
				const jqPickerEl = jq(picker.element);
				jqPickerEl.find('.k-colorpicker-seleted-color').removeClass('k-colorpicker-seleted-color');
				jqPickerEl.find('[data-name="k-' + hex.substr(1).toLowerCase() + '"]').addClass('k-colorpicker-seleted-color');
			});
		};
		return btn;
	},
	fontColor: function (data) {
		let self = this;
		let wgt = self._wgt;
		let pp = new zss.KMenupopup(wgt, 'fontColor');
		let btn = newKActionToolbarbutton(self, 'fontColor', {skipAction: true});
		var colorPicker;
		btn.setPopup(pp);
		pp.afterBind = function () {
			btn.inner.appendChild(jq('<div/>', {class: 'color', style: 'background-color: #000000'})[0]);
		};
		btn.afterBind = function () {
			let jqBtnInner = jq(btn.inner);
			jqBtnInner.on('click', function (evt) {
				let hexColor = self.rgbToHex(jqBtnInner.find('.color').css('backgroundColor'));
				let sht = wgt.sheetCtrl;
				if (sht) {
					wgt.fireToolbarAction('fontColor', {color: hexColor, selection: sht._getToolBarSelectionData()}); //ZSS-717
				}
			});
			jq(btn.dropdownButton).on('mousedown', function (evt) {
				// KEIKAI-200: lazy loading color picker
				if (!colorPicker) {
					colorPicker = new zss.Colorpicker(self, 'fontColor', btn);
					pp.appendChild(colorPicker);
					colorPicker.render();
					colorPicker.bind();
				}
				const picker = colorPicker.picker;
				let color;
				const sht = wgt.sheetCtrl;
				if (sht) {
					const pos = sht.getLastFocus();
					if (pos) {
						const cell = sht.getCell(pos.row, pos.column);
						color = cell.$n('real').style.color;
					}
				}
				picker.setValue(color || '#000000');
				let hex = colorPicker.picker.color.toHexString();
				jq(colorPicker.picker.element).find('.k-colorpicker-seleted-color').removeClass('k-colorpicker-seleted-color');
				jq(colorPicker.picker.element).find('[data-name="k-' + hex.substr(1).toLowerCase() + '"]').addClass('k-colorpicker-seleted-color');
			});
		};
		return btn;
	},
	verticalAlign: function (data) {
		let wgt = this._wgt,
			btn = newKActionToolbarbutton(this, 'verticalAlign', {skipAction: true, updateBtn: true});
		btn.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).verticalAlign()));
		return btn;
	},
	horizontalAlign: function (data) {
		let wgt = this._wgt,
			btn = newKActionToolbarbutton(this, 'horizontalAlign', {skipAction: true, updateBtn: true});
		btn.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).horizontalAlign()));
		return btn;
	},
	textIndentIncrease: function (data) {
		return newKActionToolbarbutton(this, 'textIndentIncrease');
	},
	textIndentDecrease: function (data) {
		return newKActionToolbarbutton(this, 'textIndentDecrease');
	},
	wrapText: function (data) {
		return newKActionToolbarbutton(this, 'wrapText', {updateBtn: true, getterFunction: 'isWrap'});
	},
	mergeAndCenter: function (data) {
		let wgt = this._wgt,
			btn = newKActionToolbarbutton(this, 'mergeAndCenter');
		btn.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).mergeAndCenter()));
		return btn;
	},
	insert: function (data) {
		let wgt = this._wgt,
			btn = newKActionToolbarbutton(this, 'insert', {skipAction: true});
		btn.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).insert()));
		return btn;
	},
	del: function (data) {
		let wgt = this._wgt,
			btn = newKActionToolbarbutton(this, 'del', {skipAction: true});
		btn.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).del()));
		return btn;
	},
	format: function (data) {
		//TODO: format
	},
	insertPicture: function (data) {
		return newKActionToolbarbutton(this, 'insertPicture');
	},
	insertChart: function (data) {
		let wgt = this._wgt,
			btn = newKActionToolbarbutton(this, 'insertChart', {skipAction: true});
		btn.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).insertChart()));
		return btn;
	},
//	columnChart: function (data) {
//		var wgt = this._wgt,
//			btn = newActionToolbarbutton(wgt, 'columnChart', null, data, true),
//			b = btn[0];
//		b.setClickDisabled(true);
//		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).columnChart()));
//		return btn;
//	},
//	lineChart: function (data) {
//		var wgt = this._wgt,
//			btn = newActionToolbarbutton(wgt, 'lineChart', null, data, true),
//			b = btn[0];
//		b.setClickDisabled(true);
//		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).lineChart()));
//		return btn;
//	},
//	pieChart: function (data) {
//		var wgt = this._wgt,
//			btn = newActionToolbarbutton(wgt, 'pieChart', data, true),
//			b = btn[0];
//		b.setClickDisabled(true);
//		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).pieChart()));
//		return btn;
//	},
//	barChart: function (data) {
//		var wgt = this._wgt,
//			btn = newActionToolbarbutton(wgt, 'barChart', data, true),
//			b = btn[0];
//		b.setClickDisabled(true);
//		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).barChart()));
//		return btn;
//	},
//	areaChart: function (data) {
//		var b = newActionToolbarbutton(this._wgt, 'areaChart', null, data, true);
//		return b;
//	},
//	scatterChart: function (data) {
//		return newActionToolbarbutton(this._wgt, 'scatterChart', null, data, true);
//	},
//	otherChart: function (data) {
//		var wgt = this._wgt,
//			btn = newActionToolbarbutton(wgt, 'otherChart', null, data, true),
//			b = btn[0];
//		b.setClickDisabled(true);
//		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).otherChart()));
//		return btn;
//	},
	hyperlink: function (data) {
		return newKActionToolbarbutton(this, 'hyperlink');
	},
	clear: function (data) {
		let wgt = this._wgt,
			btn = newKActionToolbarbutton(this, 'clear', {skipAction: true});
		btn.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).clear()));
		return btn;
	},
	sortAndFilter: function (data) {
		let wgt = this._wgt,
			btn = newKActionToolbarbutton(this, 'sortAndFilter', {skipAction: true});
		btn.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).sortAndFilter()));
		return btn;
	},
//	autoSum: function () {
//		TODO:
//		var wgt = this._wgt,
//			b = new zss.SSToolbarbutton({
//				$action: 'autoSum',
//				tooltiptext: msgzss.action.autoSum,
//				image: data.iconURI || zk.ajaxURI('/web/zss/img/sum.png', AU)
//			}, wgt);
//		b.setPopup(new zss.MenupopupFactory(wgt).autoSum());
//		return b;
//	},
//	insertFunction: function (data) {
//		return newActionToolbarbutton(this._wgt, 'insertFunction', null, data, true);
//	},
//	financial: function data() {
//		return newActionToolbarbutton(this._wgt, 'financial', null, data, true);
//	},
//	logical: function (data) {
//		return newActionToolbarbutton(this._wgt, 'logical', null, data, true);
//	},
//	text: function (data) {
//		return newActionToolbarbutton(this._wgt, 'text', null, data, true);
//	},
//	dateAndTime: function (data) {
//		return newActionToolbarbutton(this._wgt, 'dateAndTime', null, data, true);
//	},
//	lookupAndReference: function (data) {
//		return newActionToolbarbutton(this._wgt, 'lookupAndReference', null, data, true);
//	},
//	mathAndTrig: function (data) {
//		return newActionToolbarbutton(this._wgt, 'mathAndTrig', null, data, true);
//	},
//	moreFunction: function (data) {
//		return newActionToolbarbutton(this._wgt, 'moreFunction', null, data, true);
//	},
	protectSheet: function (data) {
		return new zss.KToolbarCheckbox(this, 'protectSheet', {checkAction: 'protect'});
	},
	gridlines: function (data) {
		return new zss.KToolbarCheckbox(this, 'gridlines', {onCheckEvt: 'onDisplayGridlines', checkAction: 'show'});
	}
})
})();
