/* HeadCtrl.js

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Mon Apr 23, 2007 17:29:18 AM , Created by sam
}}IS_NOTE

Copyright (C) 2007 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
	This program is distributed under GPL Version 2.0 in the hope that
	it will be useful, but WITHOUT ANY WARRANTY.
}}IS_RIGHT
*/


(function () {
	function _ignoresizing (dg, pt, evt) {
		var ctrl = dg.control;
		ctrl.sheet.dp.stopEditing("refocus");
		var pt0 = pt[0] - (dg._unhide && ctrl.type == zss.Header.HOR ? 6 : 0),
			pt1 = pt[1] - (dg._unhide && ctrl.type != zss.Header.HOR ? 6 : 0);
		
		dg.start = [pt0, pt1];
		return dg._fixstart = false;
	}
	
	function _startDrag (dg, evt) {
		var ctrl = dg.control;
		ctrl.sheet.headerdrag = true;
		ctrl.draging = true;
	}

	function _endDrag (dg, evt) {
		var ctrl = dg.control,
			sheet = ctrl.sheet,
			cp = sheet.cp,
			rng = sheet.getLastSelection(),
			cousin = ctrl.cousin,
			unhide = dg.handle == ctrl.ibcomp2,
			idx = ctrl.index - (unhide ? 1 : 0), // KEIKAI-62, always resize previous header index
			type = sheet.selType,
			isHor = ctrl.type == zss.Header.HOR;
		
		ctrl.draging = sheet.headerdrag = false;
		if (isHor) {
			var offset = dg.last[0] - dg.start[0] + (unhide ? 1 : -1) * dg.handle.offsetWidth,
				fw = (unhide ? 0 : ctrl.orgsize) + offset,
				left = rng.left,
				right = rng.right;
			if (fw < ctrl.minHWidth) fw = ctrl.minHWidth;
			if (type == zss.SEL.COL && left <= idx && idx <= right) {
				sheet._setColumnsWidth(left, right, fw, true, true, dg._unhide? false : undefined); //undefined means depends on fw
			} else
				sheet._setColumnWidth(idx, fw, true, true, dg._unhide? false : undefined); //undefined means depends on fw
		} else {
			var offset = dg.last[1] - dg.start[1] + (unhide ? 1 : -1) * dg.handle.offsetHeight,
				fh = (unhide ? 0 : ctrl.orgsize) + offset,
				top = rng.top,
				bottom = rng.bottom;
			if (fh < ctrl.minVHeight) fh = ctrl.minVHeight;
			var CUSTOM = true; 
			if (type == zss.SEL.ROW && top <= idx && idx <= bottom) {
				sheet._setRowsHeight(top, bottom, fh, true, true, dg._unhide? false : undefined, null, CUSTOM); //undefined means depends on fh
			} else
				sheet._setRowHeight(idx, fh, true, true, dg._unhide? false : undefined, null, CUSTOM); //undefined means depends on fh
		}
		//clear header style
		if (ctrl.comp) {
			ctrl.comp.removeAttribute('style');
		}
		if (ctrl.icomp) {
			ctrl.icomp.removeAttribute('style');
		}
		if (cousin) {
			if (cousin.comp) {
				cousin.comp.removeAttribute('style');
			}
			if (cousin.icomp) {
				cousin.icomp.removeAttribute('style');
			}
		}
		if (cp.comp) {
			cp.comp.removeAttribute('style');
		}

		//gain focus and reallocate mark , then show it, 
		//don't move the focus because the cell maybe doens't exist in block anymore.		
		sheet.dp._gainFocus(true);
		
		var pos = sheet.getLastFocus(),
			ls = sheet.getLastSelection(); //must re-fetch again

		sheet.moveCellFocus(pos.row, pos.column);
		sheet.moveCellSelection(ls.left, ls.top, ls.right, ls.bottom);
		ctrl.orgsize = null;

		// delete only the mouse is left.
		if (ctrl._mouseLeaving) {
			if (ctrl.ibcomp2) {
				jq(ctrl.ibcomp2).remove();
				delete ctrl.ibcomp2;
			}
			if (ctrl.ibcomp) {
				jq(ctrl.ibcomp).remove();
				delete ctrl.ibcomp;
			}
			if (ctrl.drag) {
				ctrl.drag.destroy();
				ctrl.drag = null;
			}
		} else if (unhide) {
			if (ctrl.ibcomp2) {
				jq(ctrl.ibcomp2).remove();
				delete ctrl.ibcomp2;
			}
			if (ctrl.drag) {
				ctrl.drag.destroy();
				ctrl.drag = null;
			}
		}
	}

	
	function _snap (dg, pt) {
		var ctrl = dg.control,
			last = [pt[0], pt[1]],
			cmp = ctrl.comp,
			icmp = ctrl.icomp,
			sheet = ctrl.sheet,
			cp = sheet.cp,
			cousin = ctrl.cousin,
			unhide = dg.handle == ctrl.ibcomp2,
			isHor = ctrl.type == zss.Header.HOR;
		if (!dg._fixstart) {
			dg.start[0] -= dg.offset[0];
			dg.start[1] -= dg.offset[1];
			dg._fixstart = true;

			//when column size is 0, the head will set to display none, so, we remove the style here
			//see also zkSSheetCtrl#setColumnWidth
			//var name = "#"+this.sheetid;
			//zcss.setRule(name+" div.zscw"+this.index,"display","",true,this.sheetid+"-sheet");
			ctrl._processDrag(!dg._unhide, dg._unhide);
		}

		if (isHor) {
			if (ctrl.orgsize == null) 
				ctrl.orgsize = zk(cmp).offsetWidth();
			
			var off = dg.start[0] - pt[0],
				maxoff = ctrl.orgsize - ctrl.minHWidth;
			if (maxoff < 0) maxoff = 0;
			
			last = off >= maxoff ? [dg.start[0] - maxoff, 0] : [pt[0], 0];
			dg.last = [last[0], last[1]];

			if (unhide) {
				last[0] -= ctrl.sheet.sp.currentLeft;
				last[1] -= ctrl.sheet.sp.currentTop;
				return last;
			}
			
			//set size of column right now, but it will fail in opera
			if (!zk.opera) {
				var w, wi, ow,
					offset = last[0] - dg.start[0];
				ow = wi = w = ctrl.orgsize + offset;
				if(w < ctrl.minHWidth) w = ctrl.minHWidth;
				
				//for firefox -moz-box-size, offsetWidth is the width
				cmp.removeAttribute('style');
				if (ow < 5) {
					jq(cmp).css('padding', 0);
					if (ow <= 0)
						jq(cmp).css('border-right', 'none');
				}
				if (zk.gecko)
					wi = zk(cmp).revisedWidth(w); 
				else 
					w = wi = zk(cmp).revisedWidth(w);

				jq(cmp).css('width', jq.px0(w));
				jq(icmp).css('width', jq.px0(wi));
				if (cousin && cousin.comp) {
					cousin.comp.removeAttribute('style');
					if (ow < 5) {
						jq(cousin.comp).css('padding', 0);
						if (ow <= 0)
							jq(cousin.comp).css('border-right', 'none');
					}
					jq(cousin.comp).css('width', jq.px0(w));
					jq(cousin.icomp).css('width', jq.px0(wi));
				}
				//update corner panel szie cause ugly display when freeze in both directly
				//jq(cp.comp).css('width', jq.px0(cp._cornerWidth() + w - ctrl.orgsize));
			}
		} else {
			if (ctrl.orgsize == null)
				ctrl.orgsize = zk(cmp).offsetHeight();

			var off = dg.start[1] - pt[1],
				maxoff = ctrl.orgsize - ctrl.minVHeight;

			if (maxoff < 0) maxoff =0;
			last = off >= maxoff ? [0, dg.start[1] - maxoff] : last = [0, pt[1]];

			dg.last = [last[0], last[1]];

			if (unhide) {
				last[0] -= ctrl.sheet.sp.currentLeft;
				last[1] -= ctrl.sheet.sp.currentTop;
				return last;
			}

			//set size of row right now, but it will fail in opera
			if (!zk.opera) {
				var h, oh,
					offset = last[1] - dg.start[1];
				oh = h = ctrl.orgsize + offset;
				if (h < ctrl.minVHeight) h= ctrl.minVHeight;

				cmp.removeAttribute('style');
				if (oh < 5) {
					jq(cmp).css('padding', 0);
					if (oh <= 0)
						jq(cmp).css('border-bottom', 'none');
				}
				jq(cmp).css({'height': jq.px0(h - 1), 'line-height': jq.px0(h - 1)});
				jq(icmp).css({'height': jq.px0(h - 1), 'line-height': jq.px0(h - 1)});
				if (cousin && cousin.comp) {
					cousin.comp.removeAttribute('style');
					if (oh < 5) {
						jq(cousin.comp).css('padding', 0);
						if (oh <= 0)
							jq(cousin.comp).css('border-bottom', 'none');
					}
					jq(cousin.comp).css({'height': jq.px0(h - 1), 'line-height': jq.px0(h - 1)});
					jq(cousin.icomp).css({'height': jq.px0(h - 1), 'line-height': jq.px0(h - 1)});
				}
				//update corner panel szie cause ugly display when freeze in both directly
				//jq(cp.comp).css('height', jq.px0(cp._cornerHeight() + h - ctrl.orgsize));
			}
		}

		last[0] -= ctrl.sheet.sp.currentLeft;
		last[1] -= ctrl.sheet.sp.currentTop;
		return last;
	}
	
	/**
	 * Create a dom element to be drag instead of drag the element itself
	 */
	function _ghosting (dg, ofs, evt) {
		var htmlborder,
			ctrl = dg.control,
			bcmp = ctrl.ibcomp,
			bcmpw = bcmp.offsetWidth,
			bcmph = bcmp.offsetHeight,
			height = (zk.ie && zk.ie < 11) ? 2 : 3,
			width = (zk.ie && zk.ie < 11) ? 2 : 3,
			top = ofs[1] + bcmph,
			left = ofs[0] + bcmpw,
			spcomp = ctrl.sheet.sp.comp;

		if (ctrl.type == zss.Header.HOR) {
			var w = zk(spcomp).offsetWidth(),
				barHeight = (spcomp.scrollWidth - w <= 0) ? 0 : zss.Spreadsheet.scrollWidth,
			height = zk(spcomp).offsetHeight() - barHeight - bcmph;
			htmlborder = 'border-right:thin dotted #000;';
		} else {
			var h = zk(spcomp).offsetHeight(),
				barWidth = (spcomp.scrollHeight - h <= 0) ? 0 : zss.Spreadsheet.scrollWidth;
			width = zk(spcomp).offsetWidth() - barWidth - bcmpw;
			htmlborder = 'border-bottom:thin dotted #000;';
		}
		
		if (jq('#zk_sghost')) //if exists, remove it first
			jq('#zk_sghost').remove();

		var html = ['<div id="zk_sghost" style="font-size:0;line-height:0px;', htmlborder, 'position:absolute;top:', top, 'px;left:',
	            left, 'px;width:', width, 'px;height:', height, 'px;z-index:20"></div>'].join('');
		jq(document.body).append(html);
		
		return ctrl.element = jq('#zk_sghost')[0];
	}

/**
 * Header represent row/column header of the spreadsheet.
 */
var TopHeader = "H";
zss.Header = zk.$extends(zk.Widget, {
	widgetName: 'Header',
	draging: false,
	minHWidth: 0,
	minVHeight: 0,
	$init: function (sheet, type, data, cousin) {
		this.$supers(zss.Header, '$init', []);
		this.sheet = sheet;
		this.index = data.i; //header index
		this._pId = data.p; //css position index
		this.title = data.t || ''; //header title
		this.type = type;
		if (cousin) {
			this.cousin = cousin;
			cousin.cousin = this;
		}
	},
	//super
	getZclass: function () {
		var id = this._pId;
		return this.type == TopHeader ? 
				'zstopcell' + (id ? ' zsw' + id : '') : 'zsleftcell zsrow' + (id ? ' zslh' + id : '');
	},
	_getInnerClass: function () {
		var id = this._pId;
		return this.type == TopHeader ? 
				'zstopcelltxt' + (id ? ' zsw' + id : '') : 'zsleftcelltxt' + (id ? ' zslh' + id : '');
	},
	redraw: function (out) {
		out.push(this.getHtml());
	},
	getHtml: function () {
		return this.getHtmlPrologHalf();
	},
	getHtmlDom: function () {
		const uid = this.uuid;
		const isTop = this.type == TopHeader;
		const el = document.createElement('div');
		el.id = uid;
		el.setAttribute('zs.t', isTop ? 'STheader' : 'SLheader');
		el.className = this.getZclass();
		const innerEl = document.createElement('div');
		innerEl.className = this._getInnerClass();
		innerEl.innerText = this.title;
		el.appendChild(innerEl);
		return el;
	},
	getHtmlPrologHalf: function () {
		var uid = this.uuid,
			isTop = this.type == TopHeader;
		return '<div id="' + uid + '" zs.t="' + (isTop ? "STheader" : "SLheader") + '" class="' + this.getZclass() + 
			'"><div class="' + this._getInnerClass() + '">' + this.title + '</div></div>';
	},
	bind_: function (desktop, skipper, after) {
		this.$supers(zss.Header, 'bind_', arguments);

		var header = this.$n();
		
		this.comp = header;
		header.ctrl = this;
		
		this.icomp = header.firstChild;

		this.domListen_(header, 'onMouseEnter')
			.domListen_(header, 'onMouseLeave');
	},
	unbind_: function (skipper, after, keepRod) {
		if (this.ibcomp2) {
			jq(this.ibcomp2).remove();
			this.ibcomp2 = null;
		}
		if (this.ibcomp) {
			jq(this.ibcomp).remove();
			this.ibcomp = null;
		}
		if (this.drag) {
			this.drag.destroy();
			this.drag = null;
		}
		var header = this.$n();

		this.domUnlisten_(header, 'onMouseEnter')
			.domUnlisten_(header, 'onMouseLeave');
		
		this.comp = this.comp.ctrl = this.icomp = this.sheet = this.cousin = null;
		this.$supers(zss.Header, 'unbind_', arguments);
	},
	_doMouseEnter: function (evt) {
		let isHor = this.type == zss.Header.HOR;
		// KEIKAI-62
		if (this.index > 0 && this.sheet[isHor ? 'custColWidth' : 'custRowHeight'].isHidden(this.index - 1)
            // KEIKAI-354: if width or height is 0 but not hidden, we should show the resize handler as well.
            || this.sheet[isHor ? 'custColWidth' : 'custRowHeight'].getSize(this.index - 1) === 0) {
			if (!this.ibcomp2) //insert the SBoun2
				this.ibcomp2 = jq(this.$n()).before('<div id="' + this.uuid + '-bounw" class="' + (isHor ? 'zshbounw' : 'zsvbounw') + '" zs.t="SBoun2"></div>').prev()[0];
		}
		if (!this.ibcomp) {//insert the SBoun
			this.ibcomp = jq(this.$n()).after('<div id="' + this.uuid + '-bouni" class="' + (isHor ? 'zshbouni' : 'zsvbouni') + '" zs.t="SBoun"></div>').next()[0];
			this.domListen_(this.ibcomp, 'onDoubleClick', this._triggerAutoFitColumn);
		}
		delete this._mouseLeaving;
	},
    _triggerAutoFitColumn: function (evt) {
		if (jq(evt.domTarget).hasClass('zsvbouni')) return; //skip row
        var selection = this.sheet.getLastSelection();

        // single column
        if (selection == null || selection.top != 0
            || selection.bottom + 1 != this.sheet.maxRows
            // if selection is whole column, but only select single column to
            // click another column, we should treat it as single column with the
            // given column index.
            || selection.right - selection.left == 0) {
            this.sheet._wgt.fire('onAutoFitColumnWidth',
                {sheetId: this.sheet.serverSheetId, left: this.index}, {toServer: true}, 25);
        } else {
            // multiple columns
            this.sheet._wgt.fire('onAutoFitColumnWidth',
                {
                    sheetId: this.sheet.serverSheetId, left: selection.left,
                    right: selection.right
                }, {toServer: true}, 25);
        }
    },
	_doMouseLeave: function (evt) {
		if (!this.draging) {
			let self = this;
			setTimeout(function () {
				if (!self._mouseLeaving || self.draging) {
					return;
				} // ignore
				if (self.ibcomp2) {
					jq(self.ibcomp2).remove();
					delete self.ibcomp2;
				}
				if (self.ibcomp) {
                    self.domUnlisten_(self.ibcomp, 'onDoubleClick', self._triggerAutoFitColumn);

					jq(self.ibcomp).remove();
					delete self.ibcomp;
				}
				if (self.drag) {
					self.drag.destroy();
					self.drag = null;
				}
			}, 50);
		}
		this._mouseLeaving = true;
	},
	doTooltipOver_: zk.$void,
	doTooltipOut_: zk.$void,
	doClick_: function (evt) {
		if (evt.domTarget == this.ibcomp2) {
			return;// ignore for KEIKAI-62
		}
		this.sheet._doMouseleftclick(evt);
	},
	doMouseDown_: function (evt) {
		if (evt.domTarget == this.ibcomp2 || evt.domTarget == this.ibcomp) {
			return;// ignore for KEIKAI-62
		}
		this.sheet._doMousedown(evt);
	},
	doMouseUp_: function (evt) {
		if (evt.domTarget == this.ibcomp2 || evt.domTarget == this.ibcomp) {
			return;// ignore for KEIKAI-62
		}
		this.sheet._doMouseup(evt);
	},
	doRightClick_: function (evt) {
		this.sheet._doMouserightclick(evt);
	},
	doDoubleClick_: function (evt) {
		this.sheet._doMousedblclick(evt);
	},
	/**
	 * Setup column header per the new width or whether unhide the column header
	 */
	setColumnHeader: function (hidden) {
		var sheet = this.sheet,
			cmp = this.comp,
			icmp = this.icomp;
		
		jq(cmp).css('width', '');
		jq(icmp).css('width', '');
	},
	/**
	 * Setup row header per the new height or whether unhide the row header
	 */
	setRowHeader: function (hidden) {
		var sheet = this.sheet,
		cmp = this.comp,
		icmp = this.icomp;
		
		jq(cmp).css({'height': '', 'line-height': ''});
		jq(icmp).css({'height': '', 'line-height': ''});
	},
	
	/**
	 * Sets the width position index
	 * @param int the width position index
	 */
	appendZSW: function (zsw) {
		this._pId = zsw;
		jq(this.comp).addClass("zsw" + zsw);
		jq(this.icomp).addClass("zswi" + zsw);
	},
	/**
	 * Sets the height position index
	 * @param int the height position index
	 */
	appendZSH: function (zsh) {
		this._pId = zsh;
		jq(this.comp).addClass("zslh" + zsh);
		jq(this.icomp).addClass("zslh" + zsh);
	},
	/**
	 * Reset info
	 * @param int newindex new index
	 * @param string newnm title of the header
	 */
	resetInfo: function (newindex, newnm) {
		this.index = newindex;
		if (this.type == zss.Header.HOR) {
			this.c = newindex;
			jq(this.icomp).text(newnm);
		} else {
			this.r = newindex;
			jq(this.icomp).text(newnm);
		}
	},
	_processDrag: function (show, unhide) { //sizing column
		if (this.sheet.isDragging())
			return;//don't care if dragging
		
		if (show && this.drag && this.drag._unhide != unhide) {
			if (this.draging) { //drag direct from unhide thumb to size thumb, shall ignore such case 
				return;
			}
			delete this.drag;
		}
		
		//ZSS-407 Shouldn't allow to drag row/column size in protected sheet
		if(this.sheet._wgt.isProtect() &&
			!(this.type == zss.Header.HOR && this.sheet._wgt.allowFormatColumns) && 
			!(this.type == zss.Header.VER && this.sheet._wgt.allowFormatRows)) {
			return;//don't drag when protection
		}
		
		var ibcmp = unhide ? this.ibcomp2 : this.ibcomp,
			ibcmpcls = this.type == zss.Header.HOR ? 
				(unhide ? "zshbounw-over" : "zshbouni-over") : (unhide ? "zsvbounw-over" : "zsvbouni-over");
		jq(ibcmp)[show && !zss.Header.draging ? 'addClass' : 'removeClass'](ibcmpcls);
		 
		if (!this.drag) {
			var local = this;
			this.drag = new zk.Draggable(this, ibcmp, {
				//revert: true,
				constraint: (local.type == zss.Header.HOR) ? "horizontal" : "vertical",
				ghosting: _ghosting,
				snap: _snap,
				ignoredrag: _ignoresizing,
				starteffect: _startDrag,
				endeffect: _endDrag
			});
			this.drag._unhide = unhide; //indicate that this dragging is for unhide
		}
	}
}, {
	HOR: "H",
	VER: "V"
});
})();