/* Range.js

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Mon Apr 23, 2007 17:29:18 AM , Created by sam
}}IS_NOTE

Copyright (C) 2007 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
	This program is distributed under GPL Version 2.0 in the hope that
	it will be useful, but WITHOUT ANY WARRANTY.
}}IS_RIGHT
*/

/**
 * Range represent a rectangle area of cells
 */
zss.Range = zk.$extends(zk.Object, {
	left: -1,
	top: -1,
	right: -1,
	bottom: -1,
	width: -1,
	height: -1,
	$init: function (left, top, right, bottom) {
		this.$supers('$init', arguments);
		this.left = left;
		this.top = top;
		this.right = right;
		this.bottom = bottom;
		if (right !== -1) {
			this.width = right - left + 1;
		}
		if (bottom !== -1) {
			this.height = bottom - left + 1;
		}
        this.height = bottom - top + 1;
	},
	size: function () {
		var size = this.width * this.height;
		return size >= 0 ? size : 0;
	},
	reCalcSize: function () {
		this.width = this.right - this.left + 1 ;
		this.height = this.bottom - this.top + 1 ;
	},
	clone: function (){
		return new zss.Range(this.left, this.top, this.right, this.bottom);
	},
	toString: function(){
		return 'left: ' + this.left + ', top: ' + this.top + ', right: ' + this.right + ', bottom: ' + this.bottom
			+ ', width: ' + this.width + ', height: ' + this.height;
	},
	extendRight: function (size) {
		this.right += size;
		this.width += size;
	},
	extendLeft: function (size) {
		this.left -= size;
		this.width +=size;
	},
	extendBottom: function (size) {
		this.bottom += size;
		this.height += size;
	},
	extendTop: function (size) {
		this.top -= size;
		this.height += size;
	},
	shiftTop: function (size) {
		this.top -= size;
		this.bottom -= size;
	},
	shiftLeft: function (size) {
		this.left -= size;
		this.right -= size;
	},
	shiftRight: function (size) {
		this.left += size;
		this.right += size;
	},
	shiftBottom: function (size) {
		this.top += size;
		this.bottom += size;
	},
	containsCell: function (row, column) {
		return this.left <= column && column <= this.right && this.top <= row && row <= this.bottom;
	},
	contains: function (that) {
		return this.left <= that.left && this.right >= that.right
			&& this.top <= that.top && this.bottom >= that.bottom;
	},
	intersects: function (that) {
		return this.left <= that.right && this.right >= that.left &&
			this.top <= that.bottom && this.bottom >= that.top;
	},
	toJSON: function () {
		return {left: this.left, top: this.top, right: this.right, bottom: this.bottom};
	}
});