/* Button.js

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Jan 12, 2012 7:07:27 PM , Created by sam
}}IS_NOTE

Copyright (C) 2012 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
(function () {

zss.ResizeableToolbar = zk.$extends(zul.wgt.Toolbar, {
    _zclass: 'zss-toolbar',
	$init: function (wgt) {
		this.$supers(zss.ResizeableToolbar, '$init', []);
		this._wgt = wgt;
	},
	bind_: function () {
		this.$supers(zss.ResizeableToolbar, 'bind_', arguments);
		// calculate toolbar rows to add horizontal separator
		var jqTb = jq(this),
			zkTb = zk(jqTb);
		jqTb.css('width', '9999px');
		var rowHeight = zkTb.offsetHeight() - zkTb.borderHeight(),
			i = 1;
		while (i <= 6) {
			jqTb.append('<div class="zsttbhsp" style="top:' + jq.px0(i * rowHeight) + '"></div>');
			i++;
		}
		jqTb.css('width', 'auto');
		zWatch.listen({onSize: this, onFitSize: this});// KEIKAI-58
	},
	unbind_: function () {
		zWatch.unlisten({onSize: this, onFitSize: this});
		this.$supers(zss.ResizeableToolbar, 'unbind_', arguments);
	},
	//ZSS-177
	onFitSize: function () {// KEIKAI-58
		// var prevHgh = this._hgh,
		// 	curHgh = jq(this.$n('cave')).height();
		// if (!prevHgh || prevHgh != curHgh) {
		// 	var panel = this.parent,
		// 		tb = panel.getTabbox(),
		// 		zkn = jq(this.$n()).zk,
		// 		cv = this._wgt.cave,
		// 		h = curHgh + zkn.sumStyles('tb', jq.paddings) + zkn.sumStyles('tb', jq.borders);
		// 	panel.setHeight(h + 'px');
		//
		// 	tb.clearCachedSize_();//clear tabbox vflex height cache
		// 	tb.parent.clearCachedSize_();//clear north vflex height cache
		//
		// 	//1. resize top panel (toolbar)
		// 	// zWatch.fire('onFitSize', this._wgt, {reverse:true})
		//
		// 	//2. resize cave (sheet content)
		// 	this._wgt.clearCachedSize_();//clear sheet cave size
		// 	// zFlex.onSize.apply(cv);
		// 	// cv.resize();
		// }
		// this._hgh = curHgh;
	},
	//KEIKAI-126, due to zk wgt life cycle, flex 'min' would calculate first.
	//yet if the parent has no width like hlayout-inner, vflex='min' would get the wrong height
	//should calculate once more to ansure toolbar's height
	//should remove onSize after zk's fixed
	onSize: function () {
// 		var prevHgh = this._hgh,
// 			curHgh = jq(this.$n('cave')).height();
// 		if (!prevHgh || prevHgh != curHgh) {
// 			var cv = this._wgt.cave;
// 			//1. resize top panel (toolbar)
// 			zWatch.fire('onFitSize', this._wgt, {reverse:true})
// 			//2. resize cave (sheet content)
// //			this._wgt.clearCachedSize_();//clear sheet cave size
// 			zFlex.onSize.apply(cv);
// 			cv.resize();
// 		}
	}
});

zss.ToolbarTabpanel = zk.$extends(zul.tab.Tabpanel, {
	_zclass: 'zss-tabpanel',
	$init: function (actions, wgt) {
		this.$supers(zss.ToolbarTabpanel, '$init', []);
		this._wgt = wgt;
		this._actions = actions;//array
	},
	createButtonsIfNotExist: function () {
		var tb = this.toolbar;
		if (!tb) {
			tb = this.toolbar = new zss.ResizeableToolbar(this._wgt);
			var btns = new zss.ButtonBuilder(this._wgt, tb).addAll(this._actions).build();
			for (var i = 0, len = btns.length; i < len; i++) {
				var b = btns[i];
				if (b)
					tb.appendChild(b);
			}
			this.appendChild(tb);
			this.setDisabled(this._wgt.getActionDisabled());
		}
	},
	rebuildButtons: function (data) {
		if (arguments.length) {
			this._actions = data;
		}
		var tb = this.toolbar;
		if (tb) {
			this.removeChild(tb);
			this.toolbar = null;
		}
		this.createButtonsIfNotExist();
	},
	onShow: function () {
		this.createButtonsIfNotExist();
	},
	setDisabled: function (actions) {
		var tb = this.toolbar;
		if (tb && actions) {
			var btn = tb.firstChild;
			for (; btn; btn = btn.nextSibling) {
				if (!btn.setDisabled) {
					continue;
				}
				btn.setDisabled(actions);
			}	
		}
	},
	getSclass: function () {
		return 'zstbtabpanel';
	}
});

zss.ToolbarTabbox = zk.$extends(zul.tab.Tabbox, {
    _zclass: 'zss-tabbox',
	$o: zk.$void,
	$init: function (wgt) {
		this.$supers(zss.ToolbarTabbox, '$init', []);
		this._wgt = wgt;
		this.setVflex('min');
		
		var tbs = new zul.tab.Tabs({_zclass: 'zss-tabs'}),
			homeTab = new zul.tab.Tab({
				label: msgzss.action.homePanel,
				sclass: 'zstab-homePanel',
				_zclass: 'zss-tab'
			}),
			insertTab = new zul.tab.Tab({
				label: msgzss.action.insertPanel,
				onClick: this.proxy(this.onClickInsertTab),
				sclass: 'zstab-insertPanel',
				_zclass: 'zss-tab'
			}),
			//TODO: formulaTab = new zul.tab.Tab({
			//	label: msgzss.action.formulaPanel,
			//	onClick: this.proxy(this.onClickFormulaTab)
			//}),
			panels = new zul.tab.Tabpanels({_zclass: 'zss-tabpanels'}),
			homePanel = this.homePanel = new zss.ToolbarTabpanel(wgt.getToolbarButtons() || zss.Buttons.HOME_DEFAULT, wgt),
			//TODO: formulaPanel = this.formulaPanel = new zul.tab.Tabpanel(zss.Buttons.FORMULA_DEFAULT),
			insertPanel = this.insertPanel = new zss.ToolbarTabpanel(zss.Buttons.INSERT_DEFAULT, wgt);
//			homeToolbar = new zul.wgt.Toolbar({height: '23px'});

		this.appendChild(tbs);
		this.appendChild(panels);
		
		tbs.appendChild(homeTab);
		tbs.appendChild(insertTab);
		//TODO: tbs.appendChild(formulaTab);

		homePanel.createButtonsIfNotExist();
		panels.appendChild(homePanel);
		panels.appendChild(insertPanel);
		//TODO: panels.appendChild(formulaPanel);
		
		this.setSelectedTab(homeTab);
		
		var tb = new zul.wgt.Toolbar({
				ignoreFlexSize_: function () {
					return true;
				}, _zclass: 'zss-toolbar'
			});
		tb.appendChild(new zss.SSToolbarbutton({
			$action: 'closeBook',
			tooltiptext: msgzss.action.closeBook,
			image: zk.ajaxURI('/web/zss/img/gray-cross.png', {au: true}),
			onClick: function () {
				wgt.fireToolbarAction('closeBook');
			}
		}));
		this.appendChild(tb);
	},
	onClickInsertTab: function () {
		this.insertPanel.createButtonsIfNotExist();
	},
	onClickFormulaTab: function () {
		this.formulaPanel.createButtonsIfNotExist();
	}
});

zss.SSToolbar = zk.$extends(zul.layout.North, {
    _zclass: 'zss-north',
	$o: zk.$void,
	$init: function (wgt, actions) {
		this.$supers(zss.SSToolbar, '$init', []);
		this._cssflex = false;
		this.setBorder(0);
		this._wgt = wgt;
		this.setVflex('min');
		this._actions = actions;//array
		
		// this.appendChild(this.toolbarTabbox = new zss.ToolbarTabbox(wgt));

		var tb = this.toolbar = this.toolbarTabbox = new zss.ResizeableToolbar(this._wgt);
		var btns = new zss.ButtonBuilder(this._wgt, tb).addAll(this._actions).build();
		for (var i = 0, len = btns.length; i < len; i++) {
			var b = btns[i];
			if (b)
				tb.appendChild(b);
		}
		this.appendChild(tb);

	},
	// setDisabled: function (actions) {
	// 	var tb = this.toolbarTabbox,
	// 		panels = tb.getTabpanels(),
	// 		panel = panels.firstChild;
	// 	for (; panel; panel = panel.nextSibling) {
	// 		panel.setDisabled(actions);
	// 	}
	// },
	//	ZSS-177
	setFlexSize_: function(sz, isFlexMin) {
		var sz = this.$supers(zss.SSToolbar, 'setFlexSize_', arguments),
			ss = this.$n('real').style,//to compitiable with ZK7		
			sh = ss.height,
			$cv = jq(this.$n('cave'));
		if (sh && $cv.height() != parseInt(sh)) {
			$cv.height(sh + 'px');
		}
		return sz;
	},
	// Using beforeSize to reset LayoutRegion's size during processing onFitSize for zss.ResizeableToolbar.
	// The fixed is to fix ZK core issue that Borderlayout doesn't reset its children size in
	// the beforeSize phase when the browser resizing.
	beforeSize: function () {
		this.$n('cave').style.width = this.$n('real').style.width = ''; // reset
	} ,
	bind_: function () {
		this.$supers(zss.SSToolbar, 'bind_', arguments);
		zWatch.listen({beforeSize: this});
	},
	unbind_: function () {
		zWatch.unlisten({beforeSize: this});
		this.$supers(zss.SSToolbar, 'unbind_', arguments);
	}
});
})();