/* Util.js

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Mon Apr 23, 2007 17:29:18 AM , Created by sam
}}IS_NOTE

Copyright (C) 2007 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
	This program is distributed under GPL Version 2.0 in the hope that
	it will be useful, but WITHOUT ANY WARRANTY.
}}IS_RIGHT
*/

/**
 * Static functions for backward compatible
 */
zss.Util = zk.$extends(zk.Object, {}, {
	_vpts: {},
	_doubleVersion: null,
	getDoubleVersion: function () {
		if (this._doubleVersion == null) {
			var ver = zk.version || '10.0.0', // zk.version can be empty since zk 6.5.5
				i = ver.indexOf('.'),
				pre = ver.substring(0, i),
				dash = ver.indexOf('-');
			if (dash != -1) {
				ver = ver.substring(0, dash);
			}
			var post = ver.substr(i + 1).replace(/\./g, '');
			this._doubleVersion = parseFloat(pre + '.' + post);
		}
		return this._doubleVersion;
	},
	isCtrlKey: function (evt) {
        return this.getDoubleVersion() >= 8.5 && zk.mac ? evt.metaKey : evt.ctrlKey;
    },
	$parent: function (n) {
		var p = zss.Util._vpts[n.id];
		return p ? p : n.parentNode;
	},
	rgbToHex: function (rgbString) {
		const rgb = rgbString.split('(')[1].split(')')[0].split(',');
		const componentToHex = function (c) {
			let hex = parseInt(c).toString(16);
			return hex.length == 1 ? "0" + hex : hex;
		}
		return "#" + componentToHex(rgb[0]) + componentToHex(rgb[1]) + componentToHex(rgb[2]);
	},
	hexToRGB: function (hex) {
		var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
		return result ? {
			r: parseInt(result[1], 16),
			g: parseInt(result[2], 16),
			b: parseInt(result[3], 16)
		} : null;
	},
	capitalize: function (str) {
		return str.charAt(0).toUpperCase() + str.slice(1);
	}
});