package io.keikai.api;

import io.keikai.api.model.Book;
import io.keikai.api.model.impl.BookImpl;
import io.keikai.api.model.impl.SimpleRef;
import io.keikai.model.SBook;
import io.keikai.model.SBooks;
import io.keikai.range.impl.imexp.AbstractImporter;

/**
 * Contains factory methods to create a {@link Book}.
 */
public class Books {
    /**
     * Create a book with the bookName, e.g. Book1.xlsx
     * @param bookName
     * @return the book instance
     */
    public static Book createBook(String bookName) {
        final SBook sbook = SBooks.createBook(bookName);
        final int index = bookName.lastIndexOf(".");
        final String type = index != -1 ? bookName.substring(index + 1) : "xlsx";
        sbook.setAttribute(AbstractImporter.BOOK_TYPE_KEY, type);
        return new BookImpl(new SimpleRef<>(sbook));
    }
}
