/* AuxActionEvent.java

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		2013/05/09 , Created by dennis
}}IS_NOTE

Copyright (C) 2013 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package io.keikai.ui.event;

import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;

import io.keikai.api.AreaRef;
import io.keikai.api.AreaRefWithType;
import io.keikai.api.model.Sheet;
import io.keikai.ui.CellSelectionType;

import org.zkoss.zk.ui.Component;

/**
 * @author dennis
 * @since 3.0.0
 */
public class AuxActionEvent extends org.zkoss.zk.ui.event.Event {

	private static final long serialVersionUID = 1L;
	final Sheet sheet;
	final String action;
	final Set<AreaRefWithType> selection;
	
	public AuxActionEvent(String name, Component target, Sheet sheet, String action, AreaRef selection, Map data) {
		super(name, target, data);
		this.sheet = sheet;
		this.action = action;
		LinkedHashSet<AreaRefWithType> selSet = new LinkedHashSet<>();
		selSet.add(new AreaRefWithType(selection.getRow(), selection.getColumn(), selection.getLastRow(), selection.getLastColumn(), CellSelectionType.CELL));
		this.selection = selSet;
	}

	/**
	 * constructor of AuxActionEvent (selection set)
	 * @param name
	 * @param target
	 * @param sheet
	 * @param action
	 * @param selection
	 * @param data
	 * @since 6.0.0
	 */
	public AuxActionEvent(String name, Component target, Sheet sheet, String action, Set<AreaRefWithType> selection, Map data) {
		super(name, target, data);
		this.sheet = sheet;
		this.action = action;
		this.selection = selection;
	}

	public Sheet getSheet() {
		return sheet;
	}

	public String getAction() {
		return action;
	}

	/**
	 * @return selection (the last one if multiple)
	 */
	public AreaRef getSelection() {
		AreaRef lastSelection = null;
		for (AreaRefWithType sel : selection) {
			lastSelection = sel;
		}
		return lastSelection;
	}

	public Set<AreaRefWithType> getAllSelection() {
		return selection;
	}

	public Map getExtraData() {
		return (Map)getData();
	}
}
