/* CellMultipleSelectionEvent.java

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Nov 17, 2023 14:18:10 2023, Created by Jameschu
}}IS_NOTE

Copyright (C) 2023 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
	This program is distributed under GPL Version 2.0 in the hope that
	it will be useful, but WITHOUT ANY WARRANTY.
}}IS_RIGHT
*/
package io.keikai.ui.event;

import java.util.Set;

import io.keikai.api.AreaRefWithType;
import io.keikai.api.model.Sheet;

import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;

/**
 * Event class about selection of cell
 *
 * @author Jameschu
 * @since 6.0.0
 */
public class CellMultipleSelectionEvent extends Event {
	private static final long serialVersionUID = 1L;
	private Sheet _sheet;
	private Set<AreaRefWithType> _selectionArea;

	public CellMultipleSelectionEvent(String name, Component target, Sheet sheet, Set<AreaRefWithType> selectionArea, Object data) {
		super(name, target, data);
		_sheet = sheet;
		_selectionArea = selectionArea;
	}

	/**
	 * get Sheet
	 * @return sheet the related sheet
	 */
	public Sheet getSheet() {
		return _sheet;
	}

	/**
	 * Returns the multiple selection areas with types
	 * @return the multiple selection areas with types
	 */
	public Set<AreaRefWithType> getSelectionArea() {
		return _selectionArea;
	}
}
