/* KeyEvent.java

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Mar 21, 2012 9:47:14 AM , Created by sam
}}IS_NOTE

Copyright (C) 2012 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package io.keikai.ui.event;

import org.zkoss.zk.au.AuRequest;
import org.zkoss.zk.au.AuRequests;
import org.zkoss.zk.ui.Component;
import io.keikai.api.AreaRef;

import java.util.Map;

/**
 * @author sam
 *
 */
public class KeyEvent extends org.zkoss.zk.ui.event.KeyEvent {

	final AreaRef selection;

	private final boolean _metaKey;

	public KeyEvent(String name, Component target, int keyCode,
			boolean ctrlKey, boolean shiftKey, boolean altKey,
			int tRow, int lCol, int bRow, int rCol) {
		this(name, target, keyCode, ctrlKey, shiftKey, altKey, false, tRow, lCol, bRow, rCol);
	}

	public KeyEvent(String name, Component target, int keyCode,
			boolean ctrlKey, boolean shiftKey, boolean altKey, boolean metaKey,
			int tRow, int lCol, int bRow, int rCol) {
		super(name, target, keyCode, ctrlKey, shiftKey, altKey);
		_metaKey = metaKey;
		selection = new AreaRef(tRow, lCol, bRow, rCol);
	}

	public static final KeyEvent getZssKeyEvent(AuRequest request) {
		Map<String, Object> data = request.getData();
		return new KeyEvent(request.getCommand(), request.getComponent(), AuRequests.getInt(data, "keyCode", 0),
				AuRequests.getBoolean(data, "ctrlKey"), AuRequests.getBoolean(data, "shiftKey"),
				AuRequests.getBoolean(data, "altKey"), AuRequests.getBoolean(data, "metaKey"),
				AuRequests.getInt(data, "tRow", -1), AuRequests.getInt(data, "lCol", -1),
				AuRequests.getInt(data, "bRow", -1), AuRequests.getInt(data, "rCol", -1));
	}

	public boolean isMeta() {
		return _metaKey;
	}

	public AreaRef getSelection() {
		return selection;
	}

}
