/* BookCleaner.java

	Purpose:
		
	Description:
		
	History:
		3:38 PM 2020/1/20, Created by jumperchen

Copyright (C) 2020 Potix Corporation. All Rights Reserved.
*/
package io.keikai.ui.impl;

import java.io.Serializable;

import io.keikai.ui.Spreadsheet;
import io.keikai.ui.sys.SpreadsheetCtrl;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Desktop;
import org.zkoss.zk.ui.util.DesktopCleanup;

/**
 * clear book after desktop cleanup, to clean listener that register to a
 * book. Internal use only.
 * @since 5.1.0
 **/
public class BookCleaner implements DesktopCleanup, Serializable {

	private String _ssid;
	public BookCleaner(String ssid){
		this._ssid = ssid;
	}

	@Override
	public void cleanup(Desktop desktop) throws Exception {
		Component comp = desktop.getComponentByUuid(_ssid);
		if(comp instanceof Spreadsheet){
			try{
				Spreadsheet spreadsheet = ((Spreadsheet)comp);
				((SpreadsheetCtrl)spreadsheet.getExtraCtrl()).releaseBook();
				spreadsheet.setSrc(null); //ZSS-1329
			}catch(Exception x){}//eat
		}
	}
}
