/* StringCache.java

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Jan 13, 2012 11:11:45 AM , Created by sam
}}IS_NOTE

Copyright (C) 2012 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package io.keikai.ui.impl;

import java.io.Serializable;
import java.util.Iterator;
import java.util.LinkedHashMap;

import org.zkoss.json.JSONArray;
import org.zkoss.json.JSONAware;
import org.zkoss.json.JSONValue;

/**
 * @author sam
 *
 */
public class StringAggregation implements Serializable, JSONAware {
	private static final long serialVersionUID = 8583756133481232469L;
	
	private LinkedHashMap<String, Integer> _values = new LinkedHashMap<String, Integer>();
	
	/**
	 * Add string to aggregation
	 * 
	 * @return int the index of the string in aggregation
	 */
	public int add(String value) {
		if (_values.containsKey(value)) {
			return _values.get(value);
		} else {
			int strIndex = _values.size();
			_values.put(value, strIndex);
			return strIndex;
		}
	}

	public String toJSONString() {
		return JSONValue.toJSONString(_values.keySet());
	}

	/**
	 * Internal used only
	 * @return values
	 * @since 6.0.0
	 */
	public LinkedHashMap getValues() {
		return _values;
	}
}
